Original Contribution by [George Stocker](http://stackoverflow.com/users/16587/george-stocker) on [Stack Overflow](http://stackoverflow.com)

Original Source: [List of freely available programming books](http://web.archive.org/web/20130824154208/http://stackoverflow.com/a/392926)


### Index
* [Ada](#ada)
* [Agda](#agda)
* [Alef](#alef)
* [Android](#android)
* [APL](#apl)
* [Arduino](#arduino)
* [ASP.NET MVC](#aspnet-mvc)
* [Assembly Language](#assembly-language)
    * [Non-X86](#non-x86)
* [AutoHotkey](#autohotkey)
* [Autotools](#autotools)
* [Awk](#awk)
* [Bash](#bash)
* [Basic](#basic)
* [BETA](#beta)
* [C](#c)
* [C#](#c-sharp)
* [C++](#c-1)
* [Chapel](#chapel)
* [Cilk](#cilk)
* [Clojure](#clojure)
* [COBOL](#cobol)
* [CoffeeScript](#coffeescript)
* [ColdFusion](#coldfusion)
* [Cool](#cool)
* [Coq](#coq)
* [CUDA](#cuda)
* [D](#d)
* [Dart](#dart)
* [DB2](#db2)
* [Delphi / Pascal](#delphi--pascal)
* [DTrace](#dtrace)
* [Elasticsearch](#elasticsearch)
* [Elixir](#elixir)
* [Emacs](#emacs)
* [Embedded Systems](#embedded-systems)
* [Erlang](#erlang)
* [F#](#f-sharp)
* [Firefox OS](#firefox-os)
* [Flex](#flex)
* [Force.com](#forcecom)
* [Forth](#forth)
* [Fortran](#fortran)
* [FreeBSD](#freebsd)
* [Git](#git)
* [Go](#go)
* [Groovy](#groovy)
    * [Gradle](#gradle)
    * [Grails](#grails)
    * [Spock Framework](#spock-framework)
* [Graphical user interfaces](#graphical-user-interfaces)
* [Graphics Programming](#graphics-programming)
* [Hadoop](#hadoop)
* [Haskell](#haskell)
* [HTML / CSS](#html--css)
    * [Bootstrap](#bootstrap)
* [Icon](#icon)
* [IDL](#idl)
* [iOS](#ios)
* [Isabelle/HOL](#isabellehol)
* [J](#j)
* [Java](#java)
    * [Spring](#spring)
    * [Spring Boot](#spring-boot)
    * [Spring Security](#spring-security)
    * [Wicket](#wicket)
* [JavaScript](#javascript)
    * [Javascript frameworks](#javascript-frameworks)
    * [Node.js](#nodejs)
* [Jenkins](#jenkins)
* [Language Agnostic](#language-agnostic)
    * [Algorithms & Datastructures](#algorithms--data-structures)
    * [Cellular Automata](#cellular-automata)
    * [Cloud Computing](#cloud-computing)
    * [Competitive Programming](#competitive-programming)
    * [Compiler Design](#compiler-design)
    * [Database](#database)
    * [Datamining](#datamining)
    * [Information Retrieval](#information-retrieval)
    * [Licensing](#licensing)
    * [Machine Learning](#machine-learning)
    * [Mathematics](#mathematics)
    * [Misc](#misc)
    * [MOOC](#mooc)
    * [Networking](#networking)
    * [Open Source Ecosystem](#open-source-ecosystem)
    * [Operating systems](#operating-systems)
    * [Parallel Programming](#parallel-programming)
    * [Partial Evaluation](#partial-evaluation)
    * [Professional Development](#professional-development)
    * [Programming Paradigms](#programming-paradigms)
    * [Regular Expressions](#regular-expressions)
    * [Reverse Engineering](#reverse-engineering)
    * [Security](#security)
    * [Software Architecture](#software-architecture)
    * [Standards](#standards)
    * [Theoretical Computer Science](#theoretical-computer-science)
    * [Web Performance](#web-performance)
* [LaTeX](#latex)
* [Limbo](#limbo)
* [Linux](#linux)
* [Lisp](#lisp)
* [Lua](#lua)
* [MarkDown](#markdown)
* [Mathematica](#mathematica)
* [MATLAB](#matlab)
* [Maven](#maven)
* [Mercurial](#mercurial)
* [Mercury](#mercury)
* [Meta-Lists](#meta-lists)
* [MySQL](#mysql)
* [.NET Framework](#net-framework)
* [Neo4J](#neo4j)
* [NoSQL](#nosql)
* [Oberon](#oberon)
* [Objective-C](#objective-c)
* [OCaml](#ocaml)
* [Octave](#octave)
* [OpenGL ES](#opengl-es)
* [OpenMP](#openmp)
* [OpenSCAD](#openscad)
* [Oracle PL/SQL](#oracle-plsql)
* [Oracle Server](#oracle-server)
* [Parrot / Perl 6](#parrot--perl-6)
* [PC-BSD](#pc-bsd)
* [Perl](#perl)
* [PHP](#php)
* [PicoLisp](#picolisp)
* [PostgreSQL](#postgresql)
* [PowerShell](#powershell)
* [Processing](#processing)
* [Prolog](#prolog)
    * [Constraint Logic Programming](#constraint-logic-programming-extended-prolog)
* [PureScript](#purescript)
* [Python](#python)
    * [Django](#django)
    * [Flask](#flask)
    * [Kivy](#kivy)
    * [Pandas](#pandas)
    * [Pyramid](#pyramid)
* [QML](#qml)
* [R](#r)
* [Racket](#racket)
* [Raspberry Pi](#raspberry-pi)
* [REBOL](#rebol)
* [Ruby](#ruby)
    * [RSpec](#rspec)
    * [Sinatra](#sinatra)
    * [Ruby on Rails](#ruby-on-rails)
* [Rust](#rust)
* [Sage](#sage)
* [Scala](#scala)
    * [Lift](#lift)
    * [Play Scala](#play-scala)
* [Scheme](#scheme)
* [Scilab](#scilab)
* [Scratch](#scratch)
* [Sed](#sed)
* [Smalltalk](#smalltalk)
* [SQL (implementation agnostic)](#sql-implementation-agnostic)
* [SQL Server](#sql-server)
* [Standard ML](#standard-ml)
* [Subversion](#subversion)
* [Swift](#swift)
* [Tcl](#tcl)
* [Teradata](#teradata)
* [TeX](#tex)
* [Tizen](#tizen)
* [TLA](#tla)
* [TypeScript](#typescript)
* [Unix](#unix)
* [Verilog](#verilog)
* [VHDL](#vhdl)
* [Vim](#vim)
* [Visual Basic](#visual-basic)
* [Visual Prolog](#visual-prolog)
* [Web Services](#web-services)
* [Windows 8](#windows-8)
* [Windows Phone](#windows-phone)
* [Workflow](#workflow)
* [xBase (dBase / Clipper / Harbour)](#xbase-dbase--clipper--harbour)


### Meta-Lists
* [25 Free Computer Science Ebooks](http://www.coderholic.com/25-free-computer-science-books/)
* [atariarchives.org](http://www.atariarchives.org/) atariarchives.org makes books, information, and software for Atari and other classic computers available on the Web.
* [Bento](http://bentobox.io/)
* [Bitsavers.org](http://bitsavers.org/)
* [Bookboon: IT & Programming](http://bookboon.com/en/it-programming-ebooks)
* [Cheat Sheets (Free)](http://refcardz.dzone.com/)
* [Codingus](http://codingus.blogspot.in/)
* [conceptf1.blogspot.com](http://conceptf1.blogspot.com/2013/11/list-of-freely-available-programming.html)
* [Free Smalltalk Books, collected by Stéphane Ducasse](http://stephane.ducasse.free.fr/FreeBooks.html)
* [Free Tech Books](http://www.freetechbooks.com/)
* [Hacker Shelf](http://hackershelf.com/browse/)
* [IBM Redbooks](http://www.redbooks.ibm.com/)
* [InfoQ Minibooks](http://www.infoq.com/minibooks/)
* [InTech: Computer and Information Science](http://www.intechopen.com/subjects/computer-and-information-science)
* [JSBooks - directory of free javascript ebooks](https://github.com/revolunet/JSbooks)
* [Learn X in Y minutes](http://learnxinyminutes.com/)
* [Learneroo Resources to Learn Programming](https://www.learneroo.com/modules/12/nodes/96)
* [Microsoft Guides to Software](http://blogs.msdn.com/b/mssmallbiz/archive/2014/07/07/largest-collection-of-free-microsoft-ebooks-ever-including-windows-8-1-windows-8-windows-7-office-2013-office-365-office-2010-sharepoint-2013-dynamics-crm-powershell-exchange-server-lync-2013-system-center-azure-cloud-sql.aspx)
* [Microsoft Press: Free E-Books](http://blogs.msdn.com/b/microsoft_press/archive/2011/03/03/ebooks-list-of-our-free-books.aspx)
* [Microsoft Technologies 1, including books on Windows Azure, SharePoint, Visual Studio Guide, Windows phone development, ASP.net, Office365, etc. collection by Eric Ligman](http://blogs.msdn.com/b/mssmallbiz/archive/2012/07/27/large-collection-of-free-microsoft-ebooks-for-you-including-sharepoint-visual-studio-windows-phone-windows-8-office-365-office-2010-sql-server-2012-azure-and-more.aspx)
* [Microsoft Technologies 2, including books on Windows Azure, SharePoint, Visual Studio Guide, Windows phone development, ASP.net, etc. collection by Eric Ligman](http://blogs.msdn.com/b/mssmallbiz/archive/2012/07/30/another-large-collection-of-free-microsoft-ebooks-and-resource-kits-for-you-including-sharepoint-2013-office-2013-office-365-duet-2-0-azure-cloud-windows-phone-lync-dynamics-crm-and-more.aspx?wa=wsignin1.0)
* [MindView Inc](http://www.mindviewinc.com/Books/)
* [O'Reilly's Commons](http://commons.oreilly.com/wiki/index.php/O%27Reilly_Commons)
* [O'Reilly's Open Books Project](http://oreilly.com/openbook/)
* [Papers we love](https://github.com/papers-we-love/papers-we-love)
* [Red Gate Books](http://www.red-gate.com/community/books/index)
* [Stef's Free Online Smalltalk Books](http://stephane.ducasse.free.fr/FreeBooks/)
* [TechBooksForFree.com](http://www.techbooksforfree.com/)
* [Theassayer.org](http://theassayer.org/)
* [tutorialspoint](http://www.tutorialspoint.com/)
* [Wikibooks: Programming](http://en.wikibooks.org/wiki/Category%3aComputer_programming)


### Graphics Programming
* [Blender 3D: Noob to Pro](http://en.wikibooks.org/wiki/Blender_3D%3A_Noob_to_Pro)
* [DirectX manual](http://www.xmission.com/~legalize/book/download/index.html) (draft)
* [GPU Gems](http://http.developer.nvidia.com/GPUGems/gpugems_part01.html)
* [GPU Gems 2](http://http.developer.nvidia.com/GPUGems2/gpugems2_part01.html) - [ch 8,14,18,29,30 as pdf](ftp://download.nvidia.com/developer/GPU_Gems_2/)
* [GPU Gems 3](http://http.developer.nvidia.com/GPUGems3/gpugems3_part01.html)
* [Graphics Programming Black Book](http://www.gamedev.net/page/resources/_/technical/graphics-programming-and-theory/graphics-programming-black-book-r1698)
* [Grokking the GIMP](http://gimp-savvy.com/BOOK/index.html)
* [Introduction to Modern OpenGL](http://open.gl/)
* [Learn OpenGL](http://learnopengl.com/) - Joey de Vries
* [Learning Modern 3D Graphics Programming](http://www.arcsynthesis.org/gltut/) (draft)
* [OpenGL](http://www.songho.ca/opengl/index.html) - Concepts and illustrations.
* [OpenGL Programming Guide (The Red Book)](http://fly.srk.fer.hr/~unreal/theredbook/)
* [ShaderX series](http://tog.acm.org/resources/shaderx/)
* [Tutorials for modern OpenGL](http://www.opengl-tutorial.org/)


### Graphical User Interfaces
* [Best of Smashing Magazine](http://anniversary.smashingmagazine.com/best-of-smashing-magazine.zip)
* [Programming with gtkmm 3](https://developer.gnome.org/gtkmm-tutorial/stable/)
* [Search User Interfaces](http://searchuserinterfaces.com/book/) - Marti A. Hearst
* [Working through Screens](http://www.flashbulbinteraction.com/WTS.html) - Jacob Burghardt


### Language Agnostic
#### Algorithms & Data Structures
* [A Field Guide To Genetic Programming](http://dces.essex.ac.uk/staff/rpoli/gp-field-guide/toc.html)
* [Algorithmic Graph Theory](http://code.google.com/p/graphbook/)
* [Algorithms](http://algorithmics.lsi.upc.edu/docs/Dasgupta-Papadimitriou-Vazirani.pdf)
* [Algorithms, 4th Edition](http://algs4.cs.princeton.edu/home/) - Robert Sedgewick and Kevin Wayne
* [Algorithms and Automatic Computing Machines (1963)](https://archive.org/details/Algorithms_And_Automatic_Computing_Machines) - B. A. Trakhtenbrot
* [Algorithms and Complexity](http://www.math.upenn.edu/~wilf/AlgoComp.pdf) (PDF)
* [Algorithms and Data-Structures](http://www.ethoberon.ethz.ch/WirthPubl/AD.pdf) (PDF)
* [Algorithms Course Materials](http://compgeom.cs.uiuc.edu/~jeffe/teaching/algorithms/) - Jeff Erickson
* [Analysis and Design of Algorithms](http://www.cse.iitd.ernet.in/~ssen/csl356/admin356.html) - Sandeep Sen, IIT Delhi
* [Animated Algorithm and Data Structure Visualization](http://visualgo.net/) (Resource)
* [Binary Trees](http://cslibrary.stanford.edu/110/BinaryTrees.pdf) (PDF)
* [Clever Algorithms](http://www.cleveralgorithms.com/nature-inspired/index.html)
* [CS Unplugged: Computer Science without a computer](http://csunplugged.org/books/)
* [Data Structures](http://www.cse.iitd.ernet.in/~suban/cs130/index.html) - Prof. Subhashis Banerjee, IIT Delhi
* [Data Structures and Algorithms: Annotated Reference with Examples](https://drive.google.com/file/d/0B48k2jhdQ5P2aVlmMFB1UUJLczA/edit?usp=sharing)
* [Data Structures Succinctly Part 1, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/datastructurespart1) (PDF, Kindle) *(Just fill the fields with any values)*
* [Data Structures Succinctly Part 2, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/datastructurespart2) (PDF, Kindle) *(Just fill the fields with any values)*
* [Elementary Algorithms](https://github.com/liuxinyu95/AlgoXY) - Larry LIU Xinyu
* [Foundations of Computer Science](http://infolab.stanford.edu/~ullman/focs.html) - Al Aho and Jeff Ullman
* [Handbook of Graph Drawing and Visualization](https://cs.brown.edu/~rt/gdhandbook/)
* [Lectures Notes on Algorithm Analysis and Computational Complexity (Fourth Edition)](http://larc.unt.edu/ian/books/free/lnoa.pdf) - University of North Texas (PDF)
* [LEDA: A Platform for Combinatorial and Geometric Computing](http://www.mpi-inf.mpg.de/~mehlhorn/LEDAbook.html)
* [Linked List Basics](http://cslibrary.stanford.edu/103/LinkedListBasics.pdf) (PDF)
* [Linked List Problems](http://cslibrary.stanford.edu/105/LinkedListProblems.pdf) (PDF)
* [Matters Computational: Ideas, Algorithms, Source Code](http://www.jjj.de/fxt/fxtbook.pdf) (PDF)
* [Open Data Structures: An Introduction](http://www.aupress.ca/index.php/books/120226) - Pat Morin
* [Planning Algorithms](http://planning.cs.uiuc.edu/)
* [Problems on Algorithms (Second Edition)](http://larc.unt.edu/ian/books/free/poa.pdf) - University of North Texas (PDF)
* [Purely Functional Data Structures](http://www.cs.cmu.edu/~rwh/theses/okasaki.pdf) (PDF)
* [Sequential and parallel sorting algorithms](http://www.inf.fh-flensburg.de/lang/algorithmen/sortieren/algoen.htm)
* [Text Algorithms](http://igm.univ-mlv.fr/~mac/REC/text-algorithms.pdf) (PDF)
* [The Algorithm Design Manual](http://www8.cs.umu.se/kurser/TDBAfl/VT06/algorithms/BOOK/BOOK/BOOK.HTM)
* [The Art of Computer Programming](http://www.cs.utsa.edu/~wagner/knuth/) (fascicles, mostly volume 4) - Donald Knuth
* [The Design of Approximation Algorithms](http://www.designofapproxalgs.com/book.pdf) (PDF)
* [The Great Tree List Recursion Problem](http://cslibrary.stanford.edu/109/TreeListRecursion.pdf) (PDF)
* [Think Complexity](http://greenteapress.com/complexity/) (PDF)



#### Cellular Automata
* [A New Kind of Science](https://www.wolframscience.com/nksonline/toc.html) - Stephen Wolfram
* [Cellular Automata Books](http://uncomp.uwe.ac.uk/genaro/Cellular_Automata_Repository/Books.html)


#### Cloud Computing
* [Multi-tenant Applications for the Cloud, 3rd Edition](http://www.microsoft.com/en-us/download/details.aspx?id=29263)
* [OpenStack Operations Guide](http://docs.openstack.org/ops/)


#### Competitive Programming
* [Competitive Programming](http://www.comp.nus.edu.sg/~stevenha/myteaching/competitive_programming/cp1.pdf) (PDF)


#### Compiler Design
* [An Introduction to GCC](http://www.network-theory.co.uk/docs/gccintro/) - Brian Gough
* [Basics of Compiler Design (Anniversary Edition)](http://www.diku.dk/~torbenm/Basics/) - Torben Mogensen
* [Compiler Construction](http://www.ethoberon.ethz.ch/WirthPubl/CBEAll.pdf) (PDF)
* [Compiler Design in C](http://www.holub.com/software/compiler.design.in.c.html) - Allen Holub, Prentice Hall, 1990
* [Compiler Design: Theory, Tools, and Examples, C/C++ Edition](http://elvis.rowan.edu/~bergmann/books/c_cpp/) - Seth D. Bergmann
* [Compiler Design: Theory, Tools, and Examples, Java Edition](http://elvis.rowan.edu/~bergmann/books/java/) - Seth D. Bergmann
* [Compiling Scala for the Java Virtual Machine](http://lampwww.epfl.ch/~schinz/thesis-final-A4.pdf) - Michel Schinz
* [Compiling Techniques](http://www.chilton-computing.org.uk/acl/literature/books/compilingtechniques/overview.htm) - F.R.A. Hopgood, Macdonald, 1969
* [Implementing Functional Languages: A Tutorial](http://research.microsoft.com/en-us/um/people/simonpj/Papers/pj-lester-book/) - Simon Peyton Jones, David Lester
* [Let's Build a Compiler](http://www.stack.nl/~marcov/compiler.pdf) (PDF)
* [Linkers and Loaders](http://www.iecc.com/linker/) - John R. Levine
* [Practical and Theoretical Aspects of Compiler Construction](http://www.stanford.edu/class/archive/cs/cs143/cs143.1128/) (class lectures and slides)


#### Computer Vision
* [Computer Vision](http://homepages.inf.ed.ac.uk/rbf/BOOKS/BANDB/bandb.htm) - Dana Ballard, Chris Brown
* [Computer Vision: Algorithms and Applications](http://szeliski.org/Book/) - Richard Szeliski
* [Computer Vision: Models, Learning, and Inference](http://www.computervisionmodels.com/) - Simon J.D. Prince
* [Programming Computer Vision with Python](http://programmingcomputervision.com/) - Jan Erik Solem


#### Database
* [Big Data Now: Current Perspectives from O'Reilly Radar](http://shop.oreilly.com/product/0636920022640.do)
* [Database Fundamentals](http://public.dhe.ibm.com/software/dw/db2/express-c/wiki/Database_fundamentals.pdf) (PDF)
* [Foundations of Databases](http://webdam.inria.fr/Alice/)
* [Temporal Database Management](http://people.cs.aau.dk/~csj/Thesis/) - Christian S. Jensen
* [The Theory of Relational Databases](http://web.cecs.pdx.edu/~maier/TheoryBook/TRD.html)


#### Datamining
* [A Programmer's Guide to Data Mining](http://guidetodatamining.com/) (Draft) - Ron Zacharski
* [Data Jujitsu: The Art of Turning Data into Product](http://www.oreilly.com/data/free/data-jujitsu.csp) *(Just fill the fields with any values)*
* [Data Mining Algorithms In R](http://en.wikibooks.org/wiki/Data_Mining_Algorithms_In_R)
* [Internet Advertising: An Interplay among Advertisers, Online Publishers, Ad Exchanges and Web Users](http://arxiv.org/pdf/1206.1754v2.pdf) (PDF)
* [Introduction to Data Science](https://docs.google.com/file/d/0B6iefdnF22XQeVZDSkxjZ0Z5VUE/edit?pli=1) - Jeffrey Stanton
* [Mining of Massive Datasets](http://infolab.stanford.edu/~ullman/mmds.html)
* [School of Data Handbook](http://schoolofdata.org/handbook/)
* [Theory and Applications for Advanced Text Mining](http://www.intechopen.com/books/theory-and-applications-for-advanced-text-mining)


#### Information Retrieval
* [Introduction to Information Retrieval](http://nlp.stanford.edu/IR-book/information-retrieval-book.html)
* [Information Retrieval: A Survey](http://www.csee.umbc.edu/csee/research/cadip/readings/IR.report.120600.book.pdf) (PDF)


#### Licensing
* [Creative Commons: a user guide](http://www.aliprandi.org/cc-user-guide/) - Simone Aliprandi
* [The Public Domain: Enclosing the Commons of the Mind](http://www.thepublicdomain.org/download/) - James Boyle


#### Machine Learning
* [A Course in Machine Learning](http://ciml.info/dl/v0_9/ciml-v0_9-all.pdf) (PDF)
* [A First Encounter with Machine Learning](https://www.ics.uci.edu/~welling/teaching/ICS273Afall11/IntroMLBook.pdf) (PDF)
* [AI Algorithms, Data Structures, and Idioms in Prolog, Lisp, and Java](http://wps.aw.com/wps/media/objects/5771/5909832/PDF/Luger_0136070477_1.pdf) - George F. Luger, William A Stubblefield
* [An Introduction to Statistical Learning](http://www-bcf.usc.edu/~gareth/ISL/) - Gareth James, Daniela Witten, Trevor Hastie and Robert Tibshirani
* [Bayesian Reasoning and Machine Learning](http://web4.cs.ucl.ac.uk/staff/D.Barber/pmwiki/pmwiki.php?n=Brml.HomePage)
* [Gaussian Processes for Machine Learning](http://www.gaussianprocess.org/gpml/)
* [Information Theory, Inference, and Learning Algorithms](http://www.inference.phy.cam.ac.uk/itila/)
* [Introduction to Machine Learning](http://alex.smola.org/drafts/thebook.pdf) - Alex Smola and S.V.N. Vishwanathan (PDF)
* [Introduction to Machine Learning](http://arxiv.org/abs/0904.3664v1) - Amnon Shashua
* [Learning Deep Architectures for AI](http://www.iro.umontreal.ca/~bengioy/papers/ftml_book.pdf) (PDF)
* [Machine Learning](http://www.intechopen.com/books/machine_learning)
* [Machine Learning, Neural and Statistical Classification](http://www1.maths.leeds.ac.uk/~charles/statlog/whole.pdf) (PDF) or [online version](http://www1.maths.leeds.ac.uk/~charles/statlog/) - This book is based on the EC (ESPRIT) project StatLog.
* [Neural Networks and Deep Learning](http://neuralnetworksanddeeplearning.com)
* [Probabilistic Models in the Study of Language](http://idiom.ucsd.edu/~rlevy/pmsl_textbook/text.html) (Draft, with R code)
* [Reinforcement Learning: An Introduction](http://webdocs.cs.ualberta.ca/~sutton/book/ebook/the-book.html)
* [The Elements of Statistical Learning](http://www-stat.stanford.edu/~tibs/ElemStatLearn/) - Trevor Hastie, Robert Tibshirani, and Jerome Friedman
* [The LION Way: Machine Learning plus Intelligent Optimization](http://www.e-booksdirectory.com/details.php?ebook=9575)
* [The Python Game Book](http://thepythongamebook.com/en%3Astart)


#### Mathematics
* [A First Course in Linear Algebra](http://linear.ups.edu/) - Robert A. Beezer
* [An Introduction to Statistics](http://work.thaslwanter.at/Stats/html/) (with Python) - Thomas Haslwanter
* [Bayesian Methods for Hackers](https://github.com/CamDavidsonPilon/Probabilistic-Programming-and-Bayesian-Methods-for-Hackers) - Cameron Davidson-Pilon
* [Calculus Made Easy](http://www.gutenberg.org/ebooks/33283) (PDF) - Silvanus P. Thompson
* [CK-12 Probability and Statistics - Advanced](http://www.ck12.org/book/Probability-and-Statistics---Advanced-%2528Second-Edition%2529/)
* [Collaborative Statistics](http://cnx.org/content/col10522/latest/)
* [Computational Geometry](http://web.mit.edu/hyperbook/Patrikalakis-Maekawa-Cho/)
* [Concepts & Applications of Inferential Statistics](http://vassarstats.net/textbook/)
* [Differential Equations](http://tutorial.math.lamar.edu/pdf/DE/DE_Complete.pdf) - Paul Dawkins
* [Discrete Mathematics](http://home.iitk.ac.in/%7Earlal/book/mth202.pdf) (PDF) - Dr. Arbind K Lal, IIT Kanpur
* [Elementary Differential Equations](http://ramanujan.math.trinity.edu/wtrench/texts/TRENCH_DIFF_EQNS_I.PDF) - William F. Trench
* [Essentials of Metaheuristics](http://cs.gmu.edu/~sean/book/metaheuristics/) by Sean Luke
* [Graph Theory](http://compalg.inf.elte.hu/~tony/Oktatas/TDK/FINAL/)
* [Introduction to Probability and Statistics Spring 2014](http://ocw.mit.edu/courses/mathematics/18-05-introduction-to-probability-and-statistics-spring-2014/)
* [Introduction to Probability](http://www.dartmouth.edu/~chance/teaching_aids/books_articles/probability_book/book.html) - Charles M. Grinstead and J. Laurie Snell
* [Introduction to Statistical Thought](http://www.math.umass.edu/~lavine/Book/book.html) - Michael Lavine
* [Kalman and Bayesian Filters in Python](https://github.com/rlabbe/Kalman-and-Bayesian-Filters-in-Python)
* [Knapsack Problems - Algorithms and Computer Implementations](http://www.or.deis.unibo.it/knapsack.html) - Silvano Martello and Paolo Toth
* [Lecture Notes of Linear Algebra](http://home.iitk.ac.in/~psraj/mth102/lecture_notes.html) (PDF) -  Dr. P. Shunmugaraj, IIT Kanpur
* [Linear Algebra, Theory And Applications](http://www.math.byu.edu/klkuttle/linearalgebra.pdf) - Kenneth Kuttler
* [Linear Algebra: An Introduction to Mathematical Discourse](http://en.wikibooks.org/wiki/Linear_Algebra) - Jim Hefferon
* [Linear Algebra](http://home.iitk.ac.in/~arlal/book/nptel/pdf/book_linear.pdf) (PDF) - Dr. Arbind K Lal, IIT Kanpur
* [Linear Algebra](https://www.math.ucdavis.edu/~linear/linear-guest.pdf)
* [Mathematical Logic - an Introduction](http://www.ii.uib.no/~michal/und/i227/book/book.pdf) (PDF)
* [Mathematics, MTS 101A](http://home.iitk.ac.in/~psraj/mth101/) - P. Shunmugaraj, IIT Kanpur
* [Notes on Diﬀerential Equations](http://www.math.cornell.edu/~bterrell/dn.pdf) - Robert E. Terrell
* [Number Theory](https://github.com/holdenlee/number-theory) - Holden Lee MIT
* [OpenIntro Statistics](http://www.openintro.org/stat/textbook.php)
* [Ordinary Differential Equations](http://en.wikibooks.org/wiki/Ordinary_Differential_Equations)
* [Power Programming with Mathematica](http://mathematica.stackexchange.com/questions/16485/are-you-interested-in-purchasing-david-wagners-power-programming-with-mathemat/22724) - David B. Wagner
* [Probability and Statistics Cookbook](http://statistics.zone/)
* [Probability and Statistics EBook](http://wiki.stat.ucla.edu/socr/index.php/Probability_and_statistics_EBook)
* [Statistics Done Wrong](http://www.refsmmat.com/statistics/) - Alex Reinhart
* [Think Bayes: Bayesian Statistics Made Simple](http://www.greenteapress.com/thinkbayes/) - Allen B. Downey
* [Think Stats: Probability and Statistics for Programmers](http://greenteapress.com/thinkstats/) (code written in Python) - Allen B. Downey


#### Mathematics For Computer Science
* [Discrete Structures for Computer Science: Counting, Recursion, and Probability](http://cglab.ca/~michiel/DiscreteStructures/) - Michiel Smid
* [Mathematics for Computer Science (May 2015 Version)](https://courses.csail.mit.edu/6.042/spring15/mcs.pdf) (PDF) - Eric Lehman, F Thomson Leighton and Albert R Meyer


#### Misc
* [97 Things Every Programmer Should Know - Extended](https://leanpub.com/97-Things-Every-Programmer-Should-Know-Extended)
* [A Mathematical Theory of Communication](http://ieeexplore.ieee.org/stamp/stamp.jsp?tp=&arnumber=6773024) by Claude E.Shannon
* [Asterisk™: The Definitive Guide](http://asteriskdocs.org/en/3rd_Edition/asterisk-book-html-chunk/index.html)
* [Barcode Overview](http://www.tec-it.com/download/PDF/Barcode_Reference_EN.pdf)
* [Come, Let's Play: Scenario-Based Programming Using Live Sequence Charts](http://www.scribd.com/doc/175241338/Come-Let-s-Play)
* [Communicating Sequential Processes](http://www.usingcsp.com/cspbook.pdf) (PDF) by Tony Hoare
* [Computer Musings](http://scpd.stanford.edu/knuth/index.jsp) (lectures by Donald Knuth)
* [CS For All](http://www.cs.hmc.edu/csforall/)
* [Culture \& Empire: Digital Revolution](http://hintjens.com/books) (PDF)
* [Designing for Performance](http://designingforperformance.com) by Lara Hogan
* [Designing Interfaces](http://designinginterfaces.com) by Jennifer Tidwell
* [DevDocs](http://devdocs.io/) - Documents for Developers in 1 place
* [DevOps For Dummies (IBM Edition)](http://www.ibm.com/ibm/devops/us/en/resources/dummiesbooks/) (PDF)
* [Digital Signal Processing For Communications](http://www.sp4comm.org/)
* [Digital Signal Processing For Engineers and Scientists](http://www.dspguide.com/)
* [Distributed systems for fun and profit](http://book.mixu.net/distsys/single-page.html)
* [Docker Jumpstart](http://odewahn.github.io/docker-jumpstart/)
* ["DYNAMIC LINKED LIBRARIES": Paradigms of the GPL license in contemporary software](http://www.lulu.com/shop/luis-enriquez-a/dynamic-linked-libraries-paradigms-of-the-gpl-license-in-contemporary-software/ebook/product-21371318.html) - Luis A. Enríquez
* [Flow based Programming](http://jpaulmorrison.com/fbp/)
* [Foundations of Programming](http://codebetter.com/files/folders/codebetter_downloads/entry179694.aspx)
* [Game Programming Patterns](http://gameprogrammingpatterns.com/) - Bob Nystrom
* [Getting Real](http://gettingreal.37signals.com/)
* [Hacknot: Essays on Software Development](http://www.lulu.com/shop/ed-johnson/hacknot-essays-on-software-development/ebook/product-17544641.html) - Ed Johnson
* [High-Performance Scientific Computing](http://bit.ly/hpc12) (class lectures and slides)
* [How Computers Work](http://www.fastchip.net/howcomputerswork/p1.html)
* [How to Become a Programmer](http://softwarebyrob.wpengine.netdna-cdn.com/assets/Software_by_Rob%20_How_to_Become_a%20_Programmer_1.0.pdf)
* [How to Think Like a Computer Scientist](http://openbookproject.net/thinkcs/) - Peter Wentworth, Jeffrey Elkner, Allen B. Downey, and Chris Meyers
* [I Am a Bug](http://www.amibug.com/iamabug/p01.html)
* [Image Processing in C: Analyzing and Enhancing Digital Images](http://homepages.inf.ed.ac.uk/rbf/BOOKS/PHILLIPS/) - Dwayne Phillips
* [Information Technology and the Networked Economy](http://florida.theorangegrove.org/og/file/49843a6a-9a9d-4bad-b4d4-d053f9cdf73e/1/InfoTechNetworkedEconomy.pdf)
* [Learn to Program](http://pine.fm/LearnToProgram/)
* [Learning 30 Technologies in 30 Days: A Developer Challenge](https://www.openshift.com/blogs/learning-30-technologies-in-30-days-a-developer-challenge) - Shekhar Gulati
* [Linked Data Patterns: A pattern catalogue for modelling, publishing, and consuming Linked Data](http://patterns.dataincubator.org/book/) - Leigh Dodds, Ian Davis
* [Magic Ink: Information Software and The Graphical Interface](http://worrydream.com/#!/MagicInk) by Bret Victor
* [Mobile Developer's Guide to the Galaxy](https://leanpub.com/mobiledevelopersguide)
* [Modeling Reactive Systems with Statecharts](http://www.scribd.com/doc/167971960/Modeling-Reactive-Systems-With-Statecharts)
* [Mother Tongues of Computer Languages](http://www.digibarn.com/collections/posters/tongues/) (PNG)
* [Networks, Crowds, and Markets: Reasoning About a Highly Connected World](http://www.cs.cornell.edu/home/kleinber/networks-book/)
* [Object-Oriented Reengineering Patterns](http://win.ua.ac.be/~sdemey/) - Serge Demeyer, Stéphane Ducasse and Oscar Nierstrasz
* [Open Government;Collaboration, Transparency, and Participation in Practice](https://github.com/oreillymedia/open_government)
* [PDQ: Pretty Darn Quick: An Agile, All-Purpose Methodology](https://leanpub.com/PDQ) - Jeff Franz-Lien
* [Philosophy of Computer Science](http://www.cse.buffalo.edu/~rapaport/Papers/phics.pdf)
* [PNG: The Definitive Guide](http://www.libpng.org/pub/png/book/)
* [Pointers And Memory](http://cslibrary.stanford.edu/102/PointersAndMemory.pdf) (PDF)
* [Principles of Computer System Design ](http://ocw.mit.edu/resources/res-6-004-principles-of-computer-system-design-an-introduction-spring-2009/online-textbook/part_ii_open_5_0.pdf)
* [Programmer's Motivation for Beginners](http://programmersmotivation.com/)
* [Programming with Unicode](http://unicodebook.readthedocs.org/)
* [Project Oberon](http://www-old.oberon.ethz.ch/WirthPubl/ProjectOberon.pdf) (PDF)
* [Record-Playback Test Automation: Sahi & Selenium IDE: Critical Evaluation of Record-Playback Automation Tools](https://leanpub.com/manualToAutomatedWithSeleniumIDEAndSahi) - Shashikant Jagtap
* [Security Engineering](http://www.cl.cam.ac.uk/~rja14/book.html)
* [Small Memory Software](http://www.smallmemory.com/book.html)
* [SVG Essentials](http://commons.oreilly.com/wiki/index.php/SVG_Essentials)
* [The Quest for Artificial Intelligence: A History of Ideas and Achievements](http://ai.stanford.edu/~nilsson/QAI/qai.pdf) - Nils J. Nilsson
* [The Z Notation: A Reference Manual, Second Edition](http://spivey.oriel.ox.ac.uk/~mike/zrm/zrm.pdf) - J. M. Spivey


#### MOOC
* [Coursera](https://www.coursera.org/)
* [edX](https://www.edx.org/)
* [FutureLearn](https://www.futurelearn.com/)
* [MIT OCW](http://ocw.mit.edu/OcwWeb/web/home/home/index.htm)
* [NPTEL](http://nptel.ac.in/courses.php?disciplineId=106)
* [Platzi](https://courses.platzi.com/)
* [Udacity](https://www.udacity.com/)


#### Networking
* [802.11ac: A Survival Guide](http://chimera.labs.oreilly.com/books/1234000001739) - Matthew Gast
* [An Introduction to Computer Networks](http://intronetworks.cs.luc.edu) (HTML, PDF, Kindle)
* [Bits, Signals, and Packets: An Introduction to Digital Communications and Networks](http://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-02-introduction-to-eecs-ii-digital-communication-systems-fall-2012/readings/)
* [Code Connected vol.1](http://hintjens.wdfiles.com/local--files/main%3Afiles/cc1pe.pdf) (PDF) (book on ZeroMQ)
* [Computer Networking : Principles, Protocols and Practice](http://cnp3book.info.ucl.ac.be/1st/html/index.html) (HTML, ePub, PDF, Kindle)
* [High-Performance Browser Networking](http://chimera.labs.oreilly.com/books/1230000000545/index.html)
* [HTTP Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/http) (PDF, Kindle) *(Just fill the fields with any values)*
* [HTTP2 Explained](http://daniel.haxx.se/http2/) - Daniel Stenberg
* [The TCP/IP Guide](http://www.tcpipguide.com/free/t_toc.htm)
* [Understanding IP Addressing: Everything you ever wanted to know](http://www.di.unipi.it/~ricci/501302.pdf) (PDF)
* [ZeroMQ Guide](http://zguide.zeromq.org/page%3Aall)


#### Open Source Ecosystem
* [Data Journalism Handbook](http://datajournalismhandbook.org/)
* [Free as in Freedom](http://static.fsf.org/nosvn/faif-2.0.pdf) (PDF)
* [Free Software, Free Society](http://shop.fsf.org/product/free-software-free-society-2/)
* [Getting started with Open source development](http://public.dhe.ibm.com/software/dw/db2/express-c/wiki/Getting_started_with_open_source_development_p2.pdf) (PDF)
* [How to get started with open source](https://opensource.com/resources/how-get-started-open-source) (ePub & ODT)
* [Innovation Happens Elsewhere](http://dreamsongs.com/IHE/IHE.html)
* [Open Advice: FOSS: What We Wish We Had Known When We Started](http://open-advice.org/)
* [Producing Open Source Software](http://producingoss.com/)
* [The Architecture of Open Source Applications: Vol. 1: Elegance, Evolution, and a Few Fearless Hacks; Vol. 2: Structure, Scale, and a Few More Feerless Hacks](http://www.aosabook.org/en/index.html)
* [The Art of Community](http://artofcommunityonline.org/Art_of_Community_Second_Edition.pdf) (PDF) - Jono Bacon
* [The Cathedral and the Bazaar](http://www.catb.org/esr/writings/cathedral-bazaar/) - Eric S. Raymond
* [The Future of the Internet](http://futureoftheinternet.org/)
* [The Open Source Way](http://www.theopensourceway.org/book/)
* [The Performance of Open Source Applications](http://aosabook.org/en/)
* [The Wealth of Networks: How Social Production Transforms Markets and Freedom](http://cyber.law.harvard.edu/wealth_of_networks/Main_Page) - Yochai Benkler


#### Operating systems
* [Computer Science from the Bottom Up](http://www.bottomupcs.com/)
* [How to Make a Computer Operating System (Work in Progress)](https://github.com/SamyPesse/How-to-Make-a-Computer-Operating-System)
* [Operating Systems](http://www.cse.iitd.ernet.in/~suban/csl373/index.html) - Prof. Subhashis Banerjee, IIT Delhi
* [Operating Systems and Middleware](https://gustavus.edu/mcs/max/os-book/) (PDF and LaTeX)
* [Operating Systems: Three Easy Pieces](http://pages.cs.wisc.edu/~remzi/OSTEP/) (PDF)
* [Practical File System Design: The Be File System](http://www.nobius.org/~dbg/practical-file-system-design.pdf) (PDF) - Dominic Giampaolo
* [The Art of Unix Programming](http://catb.org/esr/writings/taoup/html/) - Eric S. Raymond
* [The Design and Implementation of the Anykernel and Rump Kernels](https://github.com/rumpkernel/book) - Antti Kantee
* [The little book about OS development](https://littleosbook.github.io/) - Erik Helin, Adam Renberg
* [The Little Book of Semaphores](http://greenteapress.com/semaphores/) - Allen B. Downey
* [Think OS: A Brief Introduction to Operating Systems](http://www.greenteapress.com/thinkos/index.html) (PDF) - Allen B. Downey
* [UNIX Application and System Programming, lecture notes](http://www.compsci.hunter.cuny.edu/~sweiss/course_materials/unix_lecture_notes.php) (PDFs) - Prof. Stewart Weiss
* [Xv6, a simple Unix-like teaching operating system](http://pdos.csail.mit.edu/6.828/2012/xv6.html) (PDF)


#### Parallel Programming
* [High Performance Computing](http://cnx.org/content/col11136/latest) (PDF, ePUB) - Charles Severance & Kevin Dowd
* [High Performance Computing Training](https://computing.llnl.gov/?set=training&page=index) (LLNL materials)
* [High-Performance Scientific Computing](http://bit.ly/hpc12) (class lectures and slides)
* [How to Write Parallel Programs](http://www.lindaspaces.com/book/)
* [Introduction to High-Performance Scientific Computing](http://www.tacc.utexas.edu/~eijkhout/istc/istc.html) - Victor Eijkhout
* [Introduction to Parallel Computing](https://computing.llnl.gov/tutorials/parallel_comp/) - Blaise Barney
* [Is Parallel Programming Hard, And, If So, What Can You Do About It?](https://www.kernel.org/pub/linux/kernel/people/paulmck/perfbook/perfbook.html) - Paul E. McKenney
* [Programming on Parallel Machines; GPU, Multicore, Clusters and More](http://heather.cs.ucdavis.edu/parprocbook) - Norm Matloff
* [The OpenCL Programming Book](http://www.fixstars.com/en/opencl/book/OpenCLProgrammingBook/contents/)


#### Partial Evaluation
* [Partial Evaluation and Automatic Program Generation](http://www.itu.dk/people/sestoft/pebook/) - (PDF) Jones, Gomard and Sestoft


#### Professional Development
* [Apprenticeship Patterns: Guidance for the Aspiring Software Craftsman](http://chimera.labs.oreilly.com/books/1234000001813/index.html) - David H. Hoover and Adewale Oshineye
* [Confessions of an IT Manager](http://download.red-gate.com/ebooks/DotNet/Confessions_IT_Manager.zip) *(RedGate, By Phil Factor)*
* [Don't Just Roll the Dice](http://download.red-gate.com/ebooks/DJRTD_eBook.pdf) (PDF) *(RedGate, By Neil Davidson)*
* [How to Do What You Love & Earn What You’re Worth as a Programmer](https://leanpub.com/dowhatyoulove/read) *(Leanpub, By Reginald Braithwaite)*
* [What I've Learned From Failure](https://leanpub.com/shippingsoftware/read) *(Leanpub, By Reginald Braithwaite)*
* [Why programmers work at night](https://leanpub.com/nightowls/read) *(Leanpub, By Swizec Teller)*


#### Programming Paradigms
* [Introduction to Functional Programming](http://www.cl.cam.ac.uk/teaching/Lectures/funprog-jrh-1996/) (class lectures and slides)
* [Mostly Adequate Guide to Functional Programming](https://drboolean.gitbooks.io/mostly-adequate-guide/)
* [Type Theory and Functional Programming](https://www.cs.kent.ac.uk/people/staff/sjt/TTFP/)

#### Regular Expressions
* [Learn Regex The Hard Way](http://regex.learncodethehardway.org/book/) - Zed. A. Shaw
* [RexEgg](http://www.rexegg.com/)
* [The 30 Minute Regex Tutorial](http://www.codeproject.com/Articles/9099/The-Minute-Regex-Tutorial) - Jim Hollenhorst
* [The Bastards Book of Regular Expressions: Finding Patterns in Everyday Text](https://leanpub.com/bastards-regexes) - Dan Nguyen


#### Reverse Engineering
* [Hacking the Xbox: An Introduction to Reverse Engineering](http://www.nostarch.com/xboxfree/) - Andrew "bunnie" Huang
* [Reverse Engineering for Beginners](http://beginners.re/) (PDF) - Dennis Yurichev
* [BIOS Disassembly Ninjutsu Uncovered 1st Edition](http://bioshacking.blogspot.com/2012/02/bios-disassembly-ninjutsu-uncovered-1st.html) (PDF) - Darmawan Salihun
* [iOS App Reverse Engineering](https://github.com/iosre/iOSAppReverseEngineering) (PDF)


#### Security
* [Crypto 101 - Crypto for everyone](https://www.crypto101.io/)
* [Handbook of Applied Cryptography](http://cacr.uwaterloo.ca/hac/index.html)
* [How to deal with Passwords](https://github.com/MHM5000/pass)
* [Intrusion Detection Systems with Snort](http://ptgmedia.pearsoncmg.com/images/0131407333/downloads/0131407333.pdf)
* [OpenSSL Cookbook](https://www.feistyduck.com/library/openssl-cookbook/)
* [OWASP Top 10 for .NET Developers](http://www.troyhunt.com/2011/12/free-ebook-owasp-top-10-for-net.html)
* [Security Engineering](http://www.cl.cam.ac.uk/~rja14/book.html)
* [CryptoParty Handbook](https://www.cryptoparty.in/documentation/handbook)

#### Software Architecture
* [Architectural Styles and the Design of Network-based Software Architectures](http://www.ics.uci.edu/~fielding/pubs/dissertation/top.htm) - Roy Thomas Fielding
* [Best Kept Secrets of Peer Code Review](http://smartbear.com/codecollab-code-review-book.php)
* [Data-Oriented Design](http://www.dataorienteddesign.com/dodmain/dodmain.html)
* [Domain Driven Design Quickly](http://www.infoq.com/minibooks/domain-driven-design-quickly)
* [DSL Engineering: Designing, Implementing and Using Domain-Specific Languages](http://dslbook.org/) - Markus Voelter
* [Essential Skills for Agile Development](http://elliottback.com/wp/essential-skills-for-agile-development/)
* [Guide to the Software Engineering Body of Knowledge](http://www.computer.org/portal/web/swebok)
* [How to Design Programs](http://www.htdp.org/)
* [How to Write Unmaintainable Code](http://mindprod.com/jgloss/unmain.html)
* [Kanban and Scrum - making the most of both](http://www.infoq.com/minibooks/kanban-scrum-minibook)
* [Kanban for skeptics](https://leanpub.com/kanbanforskeptics) (Leanpub, by Nick Oostvogels)
* [Methods and Techniques for the Design and Implementation of Domain-Specific Languages](http://www.st.ewi.tudelft.nl/~arie/phds/Hemel.pdf) - Zef Hemel
* [Naked objects](http://downloads.nakedobjects.net/resources/Pawson%20thesis.pdf) - Richard Pawson
* [NASA Manager Handbook for Software Development](http://homepages.inf.ed.ac.uk/dts/pm/Papers/nasa-manage.pdf) (PDF)
* [NASA Software Measurement Handbook](http://www.scribd.com/doc/7181362/NASA-Software-Measurement-Guidebook)
* [OAuth - The Big Picture](http://pages.apigee.com/oauth-big-picture-ebook.html)
* [Object-Oriented Reengineering Patterns](http://scg.unibe.ch/download/oorp/)
* [Patterns and Practices: Application Architecture Guide 2.0](http://www.codeplex.com/AppArchGuide)
* [Patterns of Software: Tales from the Software Community](http://www.dreamsongs.com/Files/PatternsOfSoftware.pdf) (PDF)
* [Practicing Domain-Driven Design](http://leanpub.com/Practicing-DDD) - Scott Millett
* [Programming Reliable Systems (Joe Armstrong's PhD thesis)](http://www.sics.se/~joe/thesis/armstrong_thesis_2003.pdf) (PDF)
* [Scrum and XP from the Trenches](http://www.infoq.com/minibooks/scrum-xp-from-the-trenches)
* [Seamless Object-Oriented Software Architecture](http://www.bon-method.com/book_print_a4.pdf) (PDF)
* [Software Engineering for Internet Applications](http://philip.greenspun.com/seia/)
* [Web API Design](https://blog.apigee.com/detail/announcement_new_ebook_on_web_api_design)
* [Your API Is Bad](https://leanpub.com/yourapiisbad) *(Leanpub, by Paddy Foran)*


#### Standards
* [Linux Standard Base](http://refspecs.linuxfoundation.org/lsb.shtml)
* [UNIX - The POSIX Standard - IEEE Std 1003.1](https://github.com/g-nix/posix-standard)


#### Theoretical Computer Science
* [An Introduction to the Theory of Computation](http://www.cse.ohio-state.edu/~gurari/theory-bk/theory-bk.html)
* [Building Blocks for Theoretical Computer Science](http://www.cs.uiuc.edu/~mfleck/building-blocks/index.html) - Margaret M. Fleck
* [Category Theory for Computing Science](http://www.tac.mta.ca/tac/reprints/articles/22/tr22.pdf) (PDF)
* [Homotopy Type Theory: Univalent Foundations of Mathematics](http://homotopytypetheory.org/book/) (PDF)
* [Introduction to Computer Science](http://www.cse.iitd.ernet.in/~suban/CSL102/) - Prof. Subhashis Banerjee, IIT Delhi
* [Introduction to Computing](http://www.computingbook.org/)
* [Introduction to Theory of Computation](http://cg.scs.carleton.ca/~michiel/TheoryOfComputation/) (PDF) - Anil Maheshwari and Michiel Smid
* [Models of Computation](http://cs.brown.edu/people/jes/book/) - John E. Savage
* [Network Science](http://barabasilab.neu.edu/networksciencebook/index.html)
* [Practical Foundations for Programming Languages, Preview](http://www.cs.cmu.edu/~rwh/plbook/book.pdf) - Robert Harper
* [Principles of Programming Languages](http://www.cs.jhu.edu/~scott/pl/book/dist/) - Scott F. Smith
* [Programming and Programming Languages](http://papl.cs.brown.edu/2014/index.html) - Shriram Krishnamurthi
* [Programming in Martin-Löf's Type Theory](http://www.cse.chalmers.se/research/group/logic/book/) - Bengt Nordstroem
* [Programming Languages: Application and Interpretation (2nd Edition)](http://www.cs.brown.edu/~sk/Publications/Books/ProgLangs/)
* [Semantics with Applications: A Formal Introduction](http://www.daimi.au.dk/~bra8130/Wiley_book/wiley.html) - Hanne Riis Nielson, Flemming Nielson
* [Structure and Interpretation of Computer Programs](http://mitpress.mit.edu/sicp/)
* [Structure and Interpretation of Computer Programs](http://sarabander.github.io/sicp/html/index.xhtml)
* [Theory of Computation](http://www.cse.iitd.ernet.in/~ssen/csl705/admin705.html) - Sandeep Sen, IIT Delhi
* [Think Complexity](http://www.greenteapress.com/compmod/) - Allen B. Downey


#### Web Performance
* [Book of Speed](http://www.bookofspeed.com/) by Stoyan Stefanov
* [High Performance Browser Networking](http://chimera.labs.oreilly.com/books/1230000000545/index.html) by Ilya Grigorik
* [Mature Optimization](http://carlos.bueno.org/optimization/mature-optimization.pdf) by Carlos Bueno


### Ada
* [A Guide to Ada for C and C++ Programmers](http://www.cs.uni.edu/~mccormic/4740/guide-c2ada.pdf) (PDF)
* [Ada Distilled](http://www.adapower.com/pdfs/AdaDistilled07-27-2003.pdf) (PDF)
* [Ada Programming](http://en.wikibooks.org/wiki/Ada_Programming)
* [Ada Reference Manual - ISO/IEC 8652:2012(E) Language and Standard Libraries](http://www.ada-auth.org/standards/12rm/RM-Final.pdf) (PDF)
* [The Big Online Book of Linux Ada Programming](http://www.pegasoft.ca/resources/boblap/book.html)


### Agda
* [Agda Tutorial](http://people.inf.elte.hu/divip/AgdaTutorial/Index.html)

### Alef
* [Alef Language Reference Manual](http://doc.cat-v.org/plan_9/2nd_edition/papers/alef/ref)

### Android
* [Agile Android Software Development](http://www.agiledroid.com) (PDF, epub, mobi - need email confirmation) by Etienne Savard
* [Android 4 App Development Essentials](http://www.techotopia.com/index.php/Android_4_App_Development_Essentials)
* [Android Programming Guide for Beginners](http://eduonix.com/offers/Android_ebook_free_offer.html) (PDF - need email confirmation)
* [Android Programming Succinctly, Syncfusion](https://www.syncfusion.com/resources/techportal/ebooks/android) ([PDF](https://www.syncfusion.com/content/downloads/ebook/Android_Programming_Succinctly.pdf) - [Kindle](https://www.syncfusion.com/content/downloads/ebook/Android_Programming_Succinctly.mobi)) *(Just fill the fields with any values)*
* [CodePath Android Cliffnotes](https://github.com/thecodepath/android_guides/wiki)
* [Coreservlets Android Programming Tutorial](http://www.coreservlets.com/android-tutorial/)
* [Expert Android and Eclipse development knowledge](http://www.vogella.com/android.html)
* [Google Android Developer Training](https://developer.android.com/training/index.html)
* [Styling Android](http://www.stylingandroid.com/)
* [The Busy Coder's Guide to Android Development](https://commonsware.com/Android/4-2-free) (PDF - older versions)
* [Tutorial Point Android Tutorial](http://www.tutorialspoint.com/android/android_tutorial.pdf) (PDF)


### APL
* [A Practical Introduction to APL1 & APL2](http://aplwiki.com/BooksAndPublications#A_Practical_Introduction_to_APL1_.26_APL2)
* [A Practical Introduction to APL3 & APL4](http://aplwiki.com/BooksAndPublications#A_Practical_Introduction_to_APL3_.26_APL4)
* [Mastering Dyalog APL](http://www.dyalog.com/intro/) (PDF)


### Arduino
* [Arduino Programming Notebook](http://www.lulu.com/shop/brian-evans/arduino-programming-notebook/ebook/product-18598708.html) - Brian Evans
* [Introduction to Arduino](http://playground.arduino.cc/Main/ManualsAndCurriculum)
* [Introduction to Arduino : A piece of cake!](http://www.introtoarduino.com) - Alan G. Smith


### ASP.NET MVC
* [ASP.NET MVC Music Store](http://mvcmusicstore.codeplex.com/)


### Assembly Language
* [An introduction to reverse engineering for beginners](https://github.com/dennis714/RE-for-beginners)
* [Assembly Language Succinctly](http://www.syncfusion.com/Content/downloads/ebook/Assembly_Language_Succinctly.pdf)
* [Introduction to Reverse Engineering Software](http://althing.cs.dartmouth.edu/local/www.acm.uiuc.edu/sigmil/RevEng/)
* [Paul Carter's Tutorial on x86 Assembly](http://drpaulcarter.com/pcasm/)
* [PC Assembly Language](http://drpaulcarter.com/pcasm/) - Paul A. Carter
* [Professional Assembly Language](http://blog.hit.edu.cn/jsx/upload/AT%EF%BC%86TAssemblyLanguage.pdf) (PDF)
* [Programming from the Ground Up](http://download.savannah.gnu.org/releases/pgubook/ProgrammingGroundUp-1-0-booksize.pdf) (PDF)
* [Ralf Brown's Interrupt List](http://www.ctyme.com/rbrown.htm)
* [Software optimization resources by Agner Fog](http://www.agner.org/optimize/)
* [The Art of Assembly Language Programming](http://courses.engr.illinois.edu/ece390/books/artofasm/artofasm.html)
* [The Second Book Of Machine Language](http://www.atariarchives.org/2bml/)
* [Wizard Code](http://vendu.twodots.nl/wizardcode.html)
* [x86 Assembly](http://en.wikibooks.org/wiki/X86_Assembly)


#### Non-X86
* [Easy 6502](http://skilldrick.github.io/easy6502/) - Nick Morgan
* [Machine Code for Beginners](http://www.worldofspectrum.org/infoseekid.cgi?id=2000227) (PDF) by Lisa Watts and Mike Wharton [Z80 and 6502 CPUs]
* [Machine Language for Beginners](http://archive.org/details/ataribooks-machine-language-for-beginners) by Richard Mansfield [6502 CPU]
* [Programmed Introduction to MIPS Assembly Language](http://chortle.ccsu.edu/AssemblyTutorial/index.html)


### AutoHotkey
* [AHKbook - the book for AutoHotkey](http://ahkscript.github.io/ahkbook/index.html)
* [AutoHotkey Official Documentation](http://ahkscript.org/docs/AutoHotkey.htm) ([CHM](http://ahkscript.org/download/1.1/AutoHotkeyHelp.zip))


### Autotools
* [Autotools Mythbuster](https://www.flameeyes.eu/autotools-mythbuster/)
* [GNU Autoconf, Automake and Libtool](http://sourceware.org/autobook/)


### Awk
* [A User's Guide for GNU AWK](http://www.math.utah.edu/docs/info/gawk_toc.html)
* [An Awk Primer](https://en.wikibooks.org/wiki/An_Awk_Primer)
* [Awk](http://www.grymoire.com/Unix/Awk.html) - Bruce Barnett


### Bash
* [Advanced Bash-Scripting Guide](http://tldp.org/LDP/abs/html/)
* [Bash Guide for Beginners](http://www.tldp.org/LDP/Bash-Beginners-Guide/html/) by Machtelt Garrels
* [BASH Programming- Mike G mikkey](http://tldp.org/HOWTO/Bash-Prog-Intro-HOWTO.html)
* [Bash Reference Manual](http://www.gnu.org/software/bash/manual/bashref.html)
* [Conquering the Command Line](http://conqueringthecommandline.com/book/frontmatter) - Mark Bates
* [Getting Started with BASH](http://www.hypexr.org/bash_tutorial.php)
* [Google Shell Style Guide](http://google-styleguide.googlecode.com/svn/trunk/shell.xml)
* [Lhunath's Bash Guide](http://mywiki.wooledge.org/BashGuide)
* [Linux Shell Scripting Tutorial - A Beginner's Handbook](http://www.freeos.com/guides/lsst/)
* [The Command Line Crash Course](http://learncodethehardway.org/cli/book/) (also a Powershell reference)
* [Writing Shell Scripts](http://linuxcommand.org/lc3_writing_shell_scripts.php) - William E. Shotts, Jr.


### Basic
* [10 PRINT CHR$(205.5+RND(1)); : GOTO 10](http://10print.org/) - Nick Montfort, Patsy Baudoin, John Bell,Ian Bogost, Jeremy Douglass, Mark C. Marino, Michael Mateas, Casey Reas, Mark Sample, Noah Vawter
* [A beginner's guide to Gambas](http://beginnersguidetogambas.com/)
* [BASIC programming language - Wikibooks](http://en.wikibooks.org/wiki/Category%3ABASIC_programming_language)
* [How To Gambas3 Guides](http://howtogambas.org/index.php?page=cedi)
* [Pick/Basic: A Programmer's Guide](http://www.jes.com/pb/) - Jonathan E. Sisk
* [Visual Basic Essentials](http://www.techotopia.com/index.php/Visual_Basic_Essentials)


### BETA
* [Object-Oriented Programming in the BETA Programming Language](http://www.daimi.au.dk/~beta/Books/) - Ole Lehrmann Madsen, Birger Møller-Pedersen, Kristen Nygaard


### C
* [A Tutorial on Pointers and Arrays in C](http://home.netcom.com/~tjensen/ptr/pointers.htm)
* [Beej's Guide to C Programming](http://beej.us/guide/bgc/)
* [Beej's Guide to Network Programming](http://beej.us/guide/bgnet/)
* [Build Your Own Lisp](http://www.buildyourownlisp.com/)
* [C Programming - Wikibooks](http://en.wikibooks.org/wiki/Programming%3AC)
* [Deep C](http://www.slideshare.net/olvemaudal/deep-c)
* [Essential C](http://cslibrary.stanford.edu/101/EssentialC.pdf) (PDF)
* [Learn C the hard way](http://c.learncodethehardway.org/book/)
* [Modern C](http://icube-icps.unistra.fr/img_auth.php/d/db/ModernC.pdf) (PDF)
* [Object Oriented Programming in C](http://www.planetpdf.com/codecuts/pdfs/ooc.pdf) (PDF)
* [Programming in C - Bharat Kinariwala & Tep Dobry](http://ee.hawaii.edu/~tep/EE160/Book/PDF/)
* [The C book](http://publications.gbdirect.co.uk/c_book/)
* [The Craft of Text Editing or A Cookbook for an Emacs](http://www.finseth.com/craft/) - Craig A. Finseth
* [The GNU C Programming Tutorial](http://www.crasseux.com/books/ctut.pdf)
* [The little book about OS development - Erik Helin, Adam Renberg](http://littleosbook.github.io/)
* [The New C Standard - An Annotated Reference](http://www.knosof.co.uk/cbook/cbook.html)
* [TONC GBA Programming - Game Boy Advance Development](http://www.coranac.com/tonc/text/toc.htm)
* [Using C on the UNIX System - David A. Curry](http://www.bitsinthewind.com/about-dac/publications/using-c-on-the-unix-system)

### C Sharp
* [Beginners Guide to C# and the.NET Micro Framework](http://www.ghielectronics.com/downloads/FEZ/Beginners%20guide%20to%20NETMF.pdf)
* [C# Essentials](http://www.techotopia.com/index.php/C_Sharp_Essentials)
* [C# Programming - Wikibook](http://en.wikibooks.org/wiki/C_Sharp_Programming)
* [C# Yellow Book](http://www.csharpcourse.com/) (intro to programming)
* [Data Structures and Algorithms with Object-Oriented Design Patterns in C#](http://www.brpreiss.com/books/opus6/)
* [Dissecting a C# Application](https://damieng.com/blog/2007/11/08/dissecting-a-c-application-inside-sharpdevelop) - Christian Holm, Bernhard Spuida, Mike Kruger
* [Fundamentals of Computer Programming with C#](http://www.introprogramming.info/english-intro-csharp-book/read-online/) - Svetlin Nakov
* [Threading in C#](http://www.albahari.com/threading/)


### C++
* [C++ Annotations](http://cppannotations.sourceforge.net/)
* [C++ Cookbook](http://staff.ppu.edu/dkhalid/O'Reilly%20-%20C++%20Cookbook%20%282007%29.pdf) (PDF)
* [C++ GUI Programming With Qt 3](http://www.computer-books.us/cpp_0010.php)
* [C++ Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/cplusplus) (PDF, Kindle) *(Just fill the fields with any values)*
* [C++ Tricks](http://www.bordoon.com/cplusplus/book_wrapper.html)
* [CS106X Programming Abstractions in C++](http://www.stanford.edu/class/cs106x/)
* [Financial Numerical Recipes in C++](http://finance.bi.no/~bernt/gcc_prog/recipes/) - Bernt Arne Ødegaard
* [Game Programming Patterns](http://gameprogrammingpatterns.com/)
* [Google's C++ Style Guide](http://google-styleguide.googlecode.com/svn/trunk/cppguide.xml)
* [How To Think Like a Computer Scientist: C++ Version](http://greenteapress.com/thinkcpp/index.html) - Allen B. Downey
* [Introduction to Design Patterns in C++ with Qt](http://ptgmedia.pearsoncmg.com/images/9780131879058/downloads/0131879057_Ezust_book.pdf)
* [Joint Strike Fighter, C++ Coding Standards, by Bjarne Stroustrup](http://www.stroustrup.com/JSF-AV-rules.pdf)
* [Learn C++.](http://www.learncpp.com/) (PDF, Online)
* [Matters Computational: Ideas, Algorithms, Source Code, by Jorg Arndt](http://www.jjj.de/fxt/fxtbook.pdf) (PDF)
* [Open Data Structures (In C++)](http://opendatastructures.org/ods-cpp.pdf) (PDF)
* [Software Design Using C++](http://cis.stvincent.edu/html/tutorials/swd/) - Br. David Carlson and Br. Isidore Minerd
* [Software optimization resources by Agner Fog](http://www.agner.org/optimize/)
* [The Boost C++ libraries](http://en.highscore.de/cpp/boost)
* [The Rook's Guide to C++](http://rooksguide.org/2013/11/26/version-1-0-is-out/) (PDF)
* [Thinking in C++, Second Edition, Vol. 1.](http://www.mindviewinc.com/downloads/TICPP-2nd-ed-Vol-one.zip) [(Vol. 2)](http://www.mindviewinc.com/downloads/TICPP-2nd-ed-Vol-two.zip) - Bruce Eckel
* Also see: [The Definitive C++ Book Guide and List](http://stackoverflow.com/q/388242/511601)


### Chapel
* [Chapel Tutorial](http://faculty.knox.edu/dbunde/teaching/chapel/)
* [Chapel Tutorial for Programmers](http://cs.colby.edu/kgburke/?resource=chapelTutorial)


### Cilk
* [Cilk 5.4.6 Reference Manual](http://supertech.csail.mit.edu/cilk/manual-5.4.6.pdf) (PDF)


### Clojure
* [A Brief Beginner’s Guide To Clojure](http://www.unexpected-vortices.com/clojure/brief-beginners-guide/)
* [Clojure - Functional Programming for the JVM](http://java.ociweb.com/mark/clojure/article.html)
* [Clojure Cheat Sheet](http://clojure.org/cheatsheet)
* [Clojure Cookbook](https://github.com/clojure-cookbook/clojure-cookbook)
* [Clojure Distilled Beginner Guide](http://yogthos.github.io/ClojureDistilled.html)
* [Clojure for the Brave and True](http://www.braveclojure.com/)
* [Clojure in Small Pieces](http://daly.axiom-developer.org/clojure.pdf) - Rich Hickey
* [Clojure Koans](http://clojurekoans.com/)
* [Clojure Programming](http://en.wikibooks.org/wiki/Clojure_Programming)
* [ClojureScript Koans](http://clojurescriptkoans.com/)
* [Data Sorcery with Clojure](http://data-sorcery.org/contents/)
* [Modern cljs](https://github.com/magomimmo/modern-cljs)
* [SICP Distilled - An idiosyncratic tour of SICP in Clojure](http://www.sicpdistilled.com/)
* [The Clojure Style Guide](https://github.com/bbatsov/clojure-style-guide)

### COBOL
* [COBOL Programming Fundamental](http://yusman.staff.gunadarma.ac.id/Downloads/files/33460/COBOL_Programming_Fundamental.pdf) (PDF)
* [OpenCOBOL 1.1 - Programmer's Guide](http://opencobol.add1tocobol.com/OpenCOBOL%20Programmers%20Guide.pdf) (PDF)


### CoffeeScript
* [CoffeeScript Cookbook](https://coffeescript-cookbook.github.io/)
* [CoffeeScript Ristretto](https://leanpub.com/coffeescript-ristretto/read) - Reginald Braithwaite
* [Smooth CoffeeScript](http://autotelicum.github.com/Smooth-CoffeeScript/SmoothCoffeeScript.html)
* [The Little Book on CoffeeScript](http://arcturo.github.com/library/coffeescript/)


### ColdFusion
* [CFML In 100 Minutes](https://github.com/mhenke/CFML-in-100-minutes/blob/master/cfml100mins.markdown)
* [Learn CF in a Week](http://learncfinaweek.com/)


### Cool
* [CoolAid: The Cool 2013 Reference Manual](http://www.cs.uwm.edu/~cs654/handouts/cool-manual.pdf) (PDF)


### Coq
* [Certified Programming with Dependent Types](http://adam.chlipala.net/cpdt/html/toc.html)
* [Software Foundations](http://www.cis.upenn.edu/~bcpierce/sf/)


### CUDA
* [OpenCL Programming Guide for CUDA Architecture](http://www.nvidia.com/content/cudazone/download/OpenCL/NVIDIA_OpenCL_ProgrammingGuide.pdf)


### D
* [D Templates Tutorial](https://github.com/PhilippeSigaud/D-templates-tutorial)
* [Programming in D](http://ddili.org/ders/d.en/)


### Dart
* [What is Dart?](http://shop.oreilly.com/product/0636920025887.do)


### DB2
* [Getting started with DB2 Express-C](http://public.dhe.ibm.com/software/dw/db2/express-c/wiki/Getting_Started_with_DB2_Express_v9.7_p4.pdf) (PDF)
* [Getting started with IBM Data Studio for DB2](http://public.dhe.ibm.com/software/dw/db2/express-c/wiki/Getting_Started_with_IBM_Data_Studio_for_DB2_p3.pdf) (PDF)
* [Getting started with IBM DB2 development](http://public.dhe.ibm.com/software/dw/db2/express-c/wiki/Getting_Started_with_DB2_App_Dev_p2.pdf) (PDF)


### Delphi / Pascal
* [Essential Pascal Version 1 and 2](http://www.marcocantu.com/epascal/)


### DTrace
* [IllumOS Dynamic Tracing Guide](http://dtrace.org/guide/preface.html)


### Elasticsearch
* [Elasticsearch: The Definitive Guide](http://www.elasticsearch.org/guide/en/elasticsearch/guide/current/index.html) ([fork it on GH](https://github.com/elasticsearch/elasticsearch-definitive-guide))
* [Exploring Elasticsearch](http://exploringelasticsearch.com/)

### Elixir
* [30 Days of Elixir](https://github.com/seven1m/30-days-of-elixir) - Tim Morgan (HTML)
* [Études for Elixir](http://chimera.labs.oreilly.com/books/1234000001642/index.html) (HTML)
* [Getting Started Guide](http://elixir-lang.org/getting-started/introduction.html) (HTML)
* [Learning Elixir](http://learningelixir.joekain.com/) - Joseph Kain Blog (HTML)


### Emacs
* [An Introduction to Programming in Emacs Lisp, 3rd Edition](https://www.gnu.org/software/emacs/manual/html_node/eintr/index.html)
* [GNU Emacs Lisp Reference Manual](http://www.gnu.org/software/emacs/manual/elisp.html)
* [GNU Emacs Manual, 17th Edition, v. 24.2](http://shop.fsf.org/product/Emacs_Manual_24/)


### Embedded Systems
* [Control and Embedded Systems](http://www.learn-c.com/) (HTML)
* [Discovering the STM32 Microcontroller](http://www.cs.indiana.edu/~geobrown/book.pdf) (PDF)
* [Introduction to Microcontrollers](http://www.embeddedrelated.com/showarticle/453.php) (HTML)


### Erlang
* [Concurrent Programming in ERLANG](http://www.erlang.org/download/erlang-book-part1.pdf) (PDF)
* [Erlang Handbook](https://github.com/esl/erlang-handbook/raw/master/output/ErlangHandbook.pdf) (PDF)
* [Erlang Programming](http://en.wikibooks.org/wiki/Erlang_Programming) (HTML)
* [Études for Erlang](http://chimera.labs.oreilly.com/books/1234000000726/index.html) - J. David Eisenberg
* [Getting Started with Erlang User's Guide](http://www.erlang.org/doc/getting_started/users_guide.html) (HTML)
* [Learn You Some Erlang For Great Good](http://learnyousomeerlang.com/) - Frederic Trottier-Hebert
* [Making reliable distributed systems in the presence of software errors](http://www.erlang.org/download/armstrong_thesis_2003.pdf) - Joe Armstrong (PDF)
* [Stuff Goes Bad: Erlang in Anger](https://s3.amazonaws.com/erlang-in-anger/text.v1.0.3.pdf) - Fred Herbert (PDF)


### F Sharp
* [F# Programming](http://en.wikibooks.org/wiki/F_Sharp_Programming) in Wikibooks
* [F# Succinctly, SyncFusion](http://www.syncfusion.com/resources/techportal/ebooks/fsharp) (PDF, Kindle) *(Just fill the fields with any values)*
* [Programming Language Concepts for Software Developers](http://www.itu.dk/courses/BPRD/E2009/plcsd-1-2.pdf) (PDF)
* [Real World Functional Programming](http://msdn.microsoft.com/en-us/library/hh314518.aspx) (MSDN Chapters)


### Flex
* [Adobe Flex 2, Programming Actionscript 3.0](http://download.macromedia.com/pub/documentation/en/flex/2/prog_actionscript30.pdf) (PDF)
* [Getting started with Adobe Flex](http://public.dhe.ibm.com/software/dw/db2/express-c/wiki/Getting_Started_with_Adobe_Flex_p2.pdf) (PDF)


### Firefox OS
* [Quick Guide For Firefox OS App Development: Creating HTML5 based apps for Firefox OS](https://leanpub.com/quickguidefirefoxosdevelopment) - Andre Garzia


### Force.com
* [Developer Workbooks](http://developer.force.com/workbook)
* [Force.com Fundamentals](http://wiki.developerforce.com/page/Force_Platform_Fundamentals)
* [Force.com Platform Fundamentals: An Introduction to Custom Application Development in the Cloud](http://www.lulu.com/shop/salesforcecom/forcecom-platform-fundamentals/ebook/product-17381451.html)
* [Heroku Postgres](http://media.developerforce.com/workbooks/HerokuPostgres_Workbooks_Web_Final.pdf) (PDF)

### Forth
* [A Beginner's Guide to Forth](http://hackershelf.com/book/482/a-beginners-guide-to-forth/)
* [And so Forth...](http://ficl.sourceforge.net/pdf/Forth_Primer.pdf) (PDF)
* [Programming Forth](http://www.mpeforth.com/arena/ProgramForth.pdf) (PDF)
* [Starting Forth](http://home.iae.nl/users/mhx/sf.html)
* [Thinking Forth](http://thinking-forth.sourceforge.net/)
* [Thoughtful Programming and Forth](http://www.ultratechnology.com/forth.htm)


### Fortran
* [Fortran programming language - Wikibooks](http://en.wikibooks.org/wiki/Category%3AFortran_programming_language)
* [Introduction to fortran 95 and numerical computing: a jump-start for scientists and engineers](http://people.cs.vt.edu/~asandu/Deposit/Fortran95_notes.pdf)
* [Self Study Guide: Programming in Fortran 95](http://www.mrao.cam.ac.uk/~rachael/compphys/SelfStudyF95.pdf)


### FreeBSD
* [Books and Articles from FreeBSD Site](http://www.freebsd.org/docs/books.html)
* [The Complete FreeBSD](http://www.lemis.com/grog/Documentation/CFBSD/)


### Git
* [A practical git introduction](http://mrchlblng.me/2014/09/practical-git-introduction/)
* [A Visual Git Reference](http://marklodato.github.io/visual-git-guide/index-en.html) - Mark Lodato
* [Conversational Git](http://blog.anvard.org/conversational-git/)
* [Git for Computer Scientists](http://eagain.net/articles/git-for-computer-scientists/)
* [Git From The Bottom Up](http://ftp.newartisans.com/pub/git.from.bottom.up.pdf) (PDF)
* [Git Immersion](http://gitimmersion.com)
* [Git internals](https://github.com/pluralsight/git-internals-pdf/raw/master/drafts/peepcode-git.pdf) - Scott Chacon (PDF)
* [Git In The Trenches](http://cbx33.github.io/gitt/index.html)
* [Git Magic](http://www-cs-students.stanford.edu/~blynn/gitmagic/)
* [Git Pocket Guide](http://chimera.labs.oreilly.com/books/1230000000561/index.html) - Richard E. Silverman
* [Git Reference](http://www.gitref.org)
* [Git Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/git) (PDF, Kindle) *(Just fill the fields with any values)*
* [git - the simple guide](http://rogerdudler.github.io/git-guide/)
* [Git Workflows](http://documentup.com/skwp/git-workflows-book)
* [GitHub Cheat Sheet](https://github.com/tiimgreen/github-cheat-sheet) - Tim Green (Markdown)
* [Learn Git - Learn Version Control with Git](http://www.git-tower.com/learn/ebook/command-line/introduction) - Tobias Günther
* [Pro Git](http://git-scm.com/book) - Scott Chacon
* [Pro Git Reedited](https://leanpub.com/progitreedited) - Jon Forrest
* [Think Like (a) Git: A Guide for the Perplexed](http://think-like-a-git.net)
* [Version Control by Example (Mercurial, Subversion, Verasity)](http://www.ericsink.com/vcbe/)


### Go
* [An Introduction to Programming in Go](http://www.golang-book.com/)
* [Building Web Apps with Go](http://codegangsta.gitbooks.io/building-web-apps-with-go/content/)
* [Effective Go](https://golang.org/doc/effective_go.html)
* [Go Bootcamp](http://www.golangbootcamp.com/book) - Matt Aimonetti
* [Go by Example](https://gobyexample.com/)
* [Learning Go](http://archive.miek.nl/projects/learninggo/index.html)
* [Let's learn Go!](http://go-book.appspot.com)
* [Network programming with Go](http://jan.newmarch.name/go/)
* [Practical Cryptography With Go](https://leanpub.com/gocrypto/read)
* [The Go Tutorial](http://golang.org/doc/go_tutorial.html)
* [The Little Go Book](https://github.com/karlseguin/the-little-go-book)


### Groovy

#### Gradle
* [Building and Testing with Gradle](http://www.gradleware.com/registered-access?content=books%2Fbuilding-and-testing%2F)
* [Building Java Projects with Gradle](http://spring.io/guides/gs/gradle/)
* [Gradle User Guide](http://www.gradle.org/docs/current/userguide/userguide.html) ([PDF](http://www.gradle.org/docs/current/userguide/userguide.pdf)) - Hans Dockter, Adam Murdoch

#### Grails
* [Getting Started with Grails](http://www.infoq.com/minibooks/grails-getting-started)
* [Grails Tutorial for Beginners](http://grails.asia/grails-tutorial-for-beginners/) - GRAILS COOKBOOK
* [The Grails Framework - Reference Documentation](http://grails.org/doc/latest/) ([PDF](http://grails.org/doc/latest/guide/single.pdf)) - Graeme Rocher, Peter Ledbrook, Marc Palmer, Jeff Brown, Luke Daley, Burt Beckwith, Lari Hotari

#### Spock Framework
* [Spock Framework Reference Documentation](https://spockframework.github.io/spock/docs/current/index.html) - Peter Niederwieser
* [Spock Intro](http://edgibbs.com/spock-intro-a-bdd-testing-framework-in-groovy/) - Ed Gibbs


### Hadoop
* [Cloudera Impala](http://www.cloudera.com/content/cloudera/en/resources/library/aboutcloudera/cloudera-impala-ebook.html) - John Russel
* [Data-Intensive Text Processing with MapReduce](http://lintool.github.io/MapReduceAlgorithms/MapReduce-book-final.pdf) (Jimmy Lin and Chris Dyer) (PDF)
* [Hadoop Illuminated](http://hadoopilluminated.com/book.php) - Mark Kerzner & Sujee Maniyam
* [Programming Pig](http://chimera.labs.oreilly.com/books/1234000001811/index.html) - Alan Gates


### Haskell
* [A Gentle Introduction to Haskell](http://www.haskell.org/tutorial/)
* [Anatomy of Programming Languages](http://www.cs.utexas.edu/~wcook/anatomy/) - William R. Cook
* [Beautiful Code, Compelling Evidence](http://vis.renci.org/jeff/2009/01/16/beautiful-code-compelling-evidence/) (PDF)
* [Exploring Generic Haskell](http://www.andres-loeh.de/ExploringGH.pdf) - Andres Löh
* [Haskell and Yesod](http://www.yesodweb.com/book-1.2)
* [Haskell no panic](http://lisperati.com/haskell/)
* [Haskell web Programming](http://yannesposito.com/Scratch/fr/blog/Yesod-tutorial-for-newbies/) (Yesod tutorial)
* [Introduction to Haskell](http://www.seas.upenn.edu/~cis194/spring13/) - Brent Yorgey
* [Learn Haskell Fast and Hard](http://yannesposito.com/Scratch/en/blog/Haskell-the-Hard-Way)
* [Learn You a Haskell for Great Good](http://learnyouahaskell.com/) - Miran Lipovaca
* [Natural Language Processing for the Working Programmer](http://nlpwp.org/book/)
* [Parallel and Concurrent Programming in Haskell](http://chimera.labs.oreilly.com/books/1230000000929/index.html) -  Simon Marlow
* [Real World Haskell](http://book.realworldhaskell.org/)
* [Speeding Through Haskell](http://www.sthaskell.com/)
* [The Haskell Road to Logic, Math and Programming](http://fldit-www.cs.uni-dortmund.de/~peter/PS07/HR.pdf) (PDF)
* [The Haskell School of Music](http://haskell.cs.yale.edu/?post_type=publication&p=112) (PDF) (work in progress)
* [Wikibook Haskell](http://en.wikibooks.org/wiki/Haskell)
* [Yet Another Haskell Tutorial](http://hal3.name/docs/daume02yaht.pdf) (PDF)


### HTML / CSS
* [A beginner's guide to HTML&CSS](http://learn.shayhowe.com/html-css/)
* [A free guide to learn HTML and CSS](http://marksheet.io/)
* [Adaptive Web Design](http://adaptivewebdesign.info/1st-edition/) - Aaron Gustafson
* [An advanced guide to HTML&CSS](http://learn.shayhowe.com/advanced-html-css/)
* [Code Guide: Standards for developing flexible, durable, and sustainable HTML and CSS](http://mdo.github.io/code-guide/) - Mark Otto
* [Dive Into HTML5](http://diveintohtml5.info/) ([PDF](http://mislav.uniqpath.com/2011/10/dive-into-html5/)) - Mark Pilgrim
* [GA Dash](http://dash.generalassemb.ly)
* [Google's HTML/CSS Style Guide](http://google-styleguide.googlecode.com/svn/trunk/htmlcssguide.xml)
* [HTML Canvas Deep Dive](http://joshondesign.com/p/books/canvasdeepdive/toc.html) - Josh Marinacci
* [HTML Dog Tutorials](http://www.htmldog.com/)
* [HTML5 Canvas](http://chimera.labs.oreilly.com/books/1234000001654/index.html) - Steve Fulton & Jeff Fulton
* [HTML5 for Publishers](http://chimera.labs.oreilly.com/books/1234000000770/index.html) - Sanders Kleinfeld
* [HTML5 For Web Designers](http://html5forwebdesigners.com/) - Jeremy Keith
* [Learn CSS Layout](http://learnlayout.com/)
* [Scalable and Modular Architecture for CSS](http://smacss.com) - Jonathan Snook
* [Web Audio API](http://chimera.labs.oreilly.com/books/1234000001552) - Boris Smus


#### Bootstrap
* [Twitter Bootstrap Succinctly](http://www.syncfusion.com/resources/techportal/ebooks/twitterbootstrap) (PDF, Kindle) *(Just fill the fields with any values)*
* [Twitter Bootstrap 3 Succinctly](http://www.syncfusion.com/resources/techportal/ebooks/twitterbootstrap3) (PDF, Kindle) *(Just fill the fields with any values)*


### Icon
* [The Implementation of the Icon Programming Language](http://www.cs.arizona.edu/icon/ibsale.htm)


### IDL
* [Getting Started with IDL](http://www.astro.virginia.edu/class/oconnell/astr511/IDLresources/getting-started-IDL-v7.0.pdf)


### iOS
* [Cocoa Dev Central](http://cocoadevcentral.com/)
* [iOS 8 App Development Essentials](http://www.techotopia.com/index.php/IOS_8_App_Development_Essentials)
* [iOS Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/ios) (PDF, Kindle) *(Just fill the fields with any values)*
* [NSHipster](http://nshipster.com/#archive) (Resource)
* [Start Developing iOS Apps Today (Objective-C) - Last updated 22.10.2013](http://everythingcomputerscience.com/books/RoadMapiOS.pdf) (PDF)
* [Start Developing iOS Apps (Swift)](https://developer.apple.com/library/prerelease/ios/referencelibrary/GettingStarted/DevelopiOSAppsSwift/index.html) (HTML)


### Isabelle/HOL
* [Concrete Semantics - A Proof Assistant Approach by Tobias Nipkow and Gerwin Klein](http://www21.in.tum.de/~nipkow/Concrete-Semantics/) (PDF)
* [Isabelle/HOL - A Proof Assistant for Higher-Order Logic by Tobias Nipkow and Lawrence C. Paulson and Markus Wenzel](http://isabelle.in.tum.de/doc/tutorial.pdf) (PDF)


### J
* [Arithmetic by Kenneth E Iverson](http://www.jsoftware.com/books/pdf/arithmetic.pdf) (PDF)
* [Brief Reference by Chris Burke and Clifford Reiter](http://www.jsoftware.com/books/pdf/brief.pdf) (PDF)
* [Calculus by Kenneth E Iverson](http://www.jsoftware.com/books/pdf/calculus.pdf) (PDF)
* [Computers and Mathematical Notation by Kenneth E Iverson](http://www.jsoftware.com/papers/camn.htm)
* [Concrete Math Companion by Kenneth E Iverson](http://www.jsoftware.com/books/pdf/cmc.pdf) (PDF)
* [Easy J by Linda Alvord, Norman Thomson (PDF)](http://www.jsoftware.com/books/pdf/easyj.pdf) || [Word DOC](http://www.jsoftware.com/books/doc/easyj_doc.zip)
* [Exploring Math by Kenneth E Iverson](http://www.jsoftware.com/books/pdf/expmath.pdf) (PDF)
* [J for C Programmers by Henry Rich- online](http://www.jsoftware.com/help/jforc/contents.htm) || [pdf](http://www.jsoftware.com/jwiki/HenryRich?action=AttachFile&do=get&target=JforC20071003.pdf) || [word 2003 file](http://www.jsoftware.com/jwiki/HenryRich?action=AttachFile&do=get&target=JforC20070929.doc)
* [J Primer](http://www.jsoftware.com/help/primer/contents.htm)
* [J Reference Card](http://www.jsoftware.com/jwiki/HenryRich?action=AttachFile&do=view&target=J602_RefCard_color_letter_current.pdf) (PDF)
* [Learning J by Roger Stokes- online](http://www.jsoftware.com/help/learning/contents.htm)
* [Math for the Layman by Kenneth E Iverson](http://www.jsoftware.com/books/pdf/mftl.zip) (zipped html+images)


### Java
* [3D Programming in Java](http://www.mat.uniroma2.it/~picard/SMC/didattica/materiali_did/Java/Java_3D/Java_3D_Programming.pdf) - Daniel Selman
* [Apache Jakarta Commons: Reusable Java Components](http://ptgmedia.pearsoncmg.com/images/0131478303/downloads/Iverson_book.pdf) - Will Iverson
* [Artificial Intelligence - Foundation of Computational Agents](http://artint.info/html/ArtInt.html)
* [Cadmus: A Primer in Java](http://java.divshot.io) - Hashan Punchihewa, Joseph Bills et al.
* [Category wise tutorials - J2EE](http://www.mkyong.com/)
* [Core Servlets and JavaServer Pages](http://pdf.coreservlets.com/) - Marty Hall and Larry Brown
* [Data Structures and Algorithms with Object-Oriented Design Patterns in Java](http://www.brpreiss.com/books/opus5/html/page9.html)
* [Data Structures in Java for the Principled Programmer](http://dept.cs.williams.edu/~bailey/JavaStructures/Book_files/JavaStructures.pdf) (PDF)
* [Google's Java Style Guide](http://google-styleguide.googlecode.com/svn/trunk/javaguide.html)
* [Introduction to Computer science using Java](http://chortle.ccsu.edu/java5/index.html)
* [Introduction to Programming in Java](http://introcs.cs.princeton.edu/java/home/) - Robert Sedgewick and Kevin Wayne
* [Introduction to Programming Using Java](http://math.hws.edu/javanotes/) - David J. Eck
* [JAAS in Action](http://www.jaasbook.com/)
* [Java Application Development on Linux by Carl Albing and Michael Schwarz (PDF)](http://www.phptr.com/content/images/013143697X/downloads/013143697X_book.pdf) (PDF)
* [Java Programming for Kids, Parents and Grandparents](http://myflex.org/books/java4kids/java4kids.htm) - Yakov Fain
* [Java Thin-Client Programming](http://www.redbooks.ibm.com/redbooks/SG245118.html)
* [Java: A Beginner's Guide](http://www.oracle.com/events/global/en/java-outreach/resources/java-a-beginners-guide-1720064.pdf) - Oracle
* [Learning Java (4th Edition)](http://chimera.labs.oreilly.com/books/1234000001805/index.html) - Patrick Niemeyer
* [NIO Framework](http://nioframework.sourceforge.net/NIO_Paper.pdf)
* [OOP - Learn Object Oriented Thinking & Programming](http://pub.bruckner.cz/titles/oop) - Rudolf Pecinovsky
* [Open Data Structures (in Java)](http://opendatastructures.org/ods-java.pdf) (PDF)
* [OSGi in Practice](http://njbartlett.name/files/osgibook_preview_20091217.pdf) (PDF)
* [Processing XML with Java (A Guide to SAX, DOM, JDOM, JAXP, and TrAX)](http://www.cafeconleche.org/books/xmljava/) - Elliotte Rusty Harold
* [Sun's Java Tutorials](http://download.oracle.com/javase/tutorial/)
* [The ABC of PDF with iText: PDF Syntax essentials](https://leanpub.com/itext_pdfabc)
* [The Java EE6 Tutorial](http://download.oracle.com/javaee/6/tutorial/doc/javaeetutorial6.pdf) (PDF)
* [The Java EE7 Tutorial](https://docs.oracle.com/javaee/7/JEETT.pdf) (PDF)
* [The Java Language Specification](http://java.sun.com/docs/books/jls/) - James Gosling, Bill Joy, Guy Steele, Gilad Bracha
* [The Java Tutorial 4th Edition](http://download.oracle.com/javase/tutorial/) - Sharon Zakhour, Scott Hommel, Jacob Royal, Isaac Rabinovitch, Tom Risser, Mark Hoeber
* [Think Java: How to Think Like a Computer Scientist](http://greenteapress.com/thinkapjava/) - Allen B. Downey
* [Thinking in Java](http://www.mindview.net/Books/TIJ/)
* [UML For Java Programmers](http://www.csd.uoc.gr/~hy252/references/UML_for_Java_Programmers-Book.pdf) - Robert Cecil Martin
* [Welcome to Java for Python Programmers](http://interactivepython.org/runestone/static/java4python/index.html) - Brad Miller
* [Welcome to the Java Workshop](http://javaworkshop.sourceforge.net/) - An Apache Project
* [What's New in Java 8](https://leanpub.com/whatsnewinjava8/read) - Adam L. Davis


#### Spring
* [Spring Framework Reference Documentation](http://docs.spring.io/spring/docs/current/spring-framework-reference/html/) ([PDF](http://docs.spring.io/spring/docs/current/spring-framework-reference/pdf/spring-framework-reference.pdf)) - Rod Johnson, Juergen Hoeller, Keith Donald, Colin Sampaleanu, Rob Harrop, Thomas Risberg, Alef Arendsen, Darren Davison, Dmitriy Kopylenko, Mark Pollack, Thierry Templier, Erwin Vervaet, Portia Tung, Ben Hale, Adrian Colyer, John Lewis, Costin Leau, Mark Fisher, Sam Brannen, Ramnivas Laddad, Arjen Poutsma, Chris Beams, Tareq Abedrabbo, Andy Clement, Dave Syer, Oliver Gierke, Rossen Stoyanchev, Phillip Webb, Rob Winch, Brian Clozel, Stephane Nicoll, Sebastien Deleuze

#### Spring Boot
* [Spring Boot Reference Guide](http://docs.spring.io/spring-boot/docs/current/reference/html/) ([PDF](http://docs.spring.io/spring-boot/docs/current/reference/pdf/spring-boot-reference.pdf) - [EPUB](http://docs.spring.io/spring-boot/docs/current/reference/epub/spring-boot-reference.epub)) - Phillip Webb, Dave Syer, Josh Long, Stéphane Nicoll, Rob Winch, Andy Wilkinson, Marcel Overdijk, Christian Dupuis

#### Spring Security
* [Spring Security Reference](http://docs.spring.io/spring-security/site/docs/current/reference/htmlsingle/) - Ben Alex, Luke Taylor, Rob Winch

#### Wicket
* [Official Free Online Guide for Apache Wicket framework](http://wicket.apache.org/learn/#guide)


### JavaScript
* [Basic JavaScript for the impatient programmer](http://www.2ality.com/2013/06/basic-javascript.html) - Dr. Axel Rauschmayer
* [Book of Modern Frontend Tooling](https://github.com/tooling/book-of-modern-frontend-tooling)
* [Crockford's JavaScript](http://www.crockford.com/javascript/) - Douglas Crockford
* [Dev Docs](http://devdocs.io/)
* [Developing Backbone.js Applications](http://addyosmani.github.io/backbone-fundamentals/) - Addy Osmani
* [Eloquent JavaScript 2nd edition](http://eloquentjavascript.net/) - Marijn Haverbeke
* [Exploring ES6](http://exploringjs.com/es6/) - Dr. Axel Rauschmayer
* [Google JavaScript Style Guide](http://google-styleguide.googlecode.com/svn/trunk/javascriptguide.xml)
* [Human Javascript](http://read.humanjavascript.com/)
* [JavaScript Allongé](https://leanpub.com/javascript-allonge/read) - Reginald Braithwaite
* [JavaScript Bible](http://media.wiley.com/product_ancillary/28/07645334/DOWNLOAD/all.pdf) (PDF)
* [JavaScript Enlightenment](http://www.javascriptenlightenment.com/) - Cody Lindley
* [JavaScript Essentials](http://www.techotopia.com/index.php/JavaScript_Essentials)
* [JavaScript For Cats](http://jsforcats.com/)
* [JavaScript Fundamentals, Plus a Dash Of JQuery - for dinner ladies](http://nicholasjohnson.com/javascript-book)
* [JavaScript Garden](http://bonsaiden.github.io/JavaScript-Garden/) (Maintained by Tim Ruffles)
* [JavaScript Patterns Collection](http://shichuan.github.io/javascript-patterns/) - Shi Chuan
* [Javascript Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/javascript) (PDF, Kindle) *(Just fill the fields with any values)*
* [JavaScript the Right Way](https://github.com/braziljs/js-the-right-way)
* [jQuery Fundamentals](http://jqfundamentals.com/) (starts with JavaScript basics)
* [JS Robots](http://markdaggett.com/images/ExpertJavaScript-ch6.pdf)
* [Leaflet Tips and Tricks: Interactive Maps Made Easy](https://leanpub.com/leaflet-tips-and-tricks) - Malcolm Maclean
* [Learn to Code JavaScript by Playing a Game](http://codecombat.com)
* [Learning JavaScript Design Patterns](http://www.addyosmani.com/resources/essentialjsdesignpatterns/book/) - Addy Osmani
* [Managing Space and Time with JavaScript - Book 1: The Basics](http://www.noelrappin.com/) - Noel Rappin
* [Marionette Exposé: Learn to write modular Javascript applicatons using Backbone Marionette and RequireJS/AMD](http://leanpub.com/marionetteexpose) - Jack Killilea
* [Mozilla Developer Network's JavaScript Guide](https://developer.mozilla.org/en/JavaScript/Guide)
* [Oh My JS](https://leanpub.com/ohmyjs/read) *(Leanpub, by Azat Mardanov)*
* [O'Reilly Programming JavaScript Applications](http://chimera.labs.oreilly.com/books/1234000000262/)
* [Patterns For Large-Scale JavaScript Application Architecture](http://addyosmani.com/largescalejavascript/) - Addy Osmani
* [Speaking JavaScript](http://speakingjs.com/es5/) - Dr. Axel Rauschmayer
* [The JavaScript Tutorial](http://javascript.info/)
* [The Problem with Native JavaScript APIs](http://chimera.labs.oreilly.com/books/1234000001655) (PDF)
* [Understanding ECMAScript 6](https://leanpub.com/understandinges6/read) *(Leanpub, by Nicholas C. Zakas)*
* [Understanding JavaScript OOP](http://robotlolita.me/2011/10/09/understanding-javascript-oop.html) *(Sorella)*
* [You Don't Know JS](https://github.com/getify/You-Dont-Know-JS)


#### Javascript Frameworks
For resources on Angular, Backbone, D3, Dojo, Ember, Express, jQuery, Knockout, Meteor, React and any other JS toolkit/framework, please refer to [Javascript Frameworks Resources and Tutorials](/javascript-frameworks-resources.md).

#### Node.js
* [An Introduction to libuv](https://nikhilm.github.io/uvbook/) - Nikhil Marathe  ([PDF](http://nikhilm.github.com/uvbook/An%20Introduction%20to%20libuv.pdf) - [ePub](http://nikhilm.github.com/uvbook/An%20Introduction%20to%20libuv.epub))
* [JavaScript and Node FUNdamentals](https://leanpub.com/jsfun/read) *(Leanpub - by Azat Mardanov)*
* [Mixu's Node Book](http://book.mixu.net/node/)
* [Node.js Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/nodejs) (PDF, Kindle) *(Just fill the fields with any values)*
* [Node: Up and Running](http://chimera.labs.oreilly.com/books/1234000001808/index.html) - Tom Hughes-Croucher
* [The Node Beginner Book](http://nodebeginner.org/)


### Jenkins
* [Jenkins: The Definitive Guide](http://www.wakaleo.com/books/jenkins-the-definitive-guide) (PDF)


### LaTeX
* [Arbirtrary LaTex Reference](http://latex.knobs-dials.com/)
* [LaTeX Wikibook](http://en.wikibooks.org/wiki/LaTeX)
* [The Not So Short Introduction to LaTeX](http://tobi.oetiker.ch/lshort/lshort.pdf) (PDF)

See also [TeX](#tex)

### Limbo
* [Inferno Programming With Limbo](http://doc.cat-v.org/inferno/books/inferno_programming_with_limbo/)

### Linux
* [Ad Hoc Data Analysis From The Unix Command Line](http://en.wikibooks.org/wiki/Ad_Hoc_Data_Analysis_From_The_Unix_Command_Line)
* [Automated Linux From Scratch](http://www.linuxfromscratch.org/alfs/download.html)
* [Getting Started with Ubuntu](http://ubuntu-manual.org/)
* [GNU Autoconf, Automake and Libtool](http://sources.redhat.com/autobook/download.html)
* [GTK+/Gnome Application Development](http://www.linuxtopia.org/online_books/gui_toolkit_guides/gtk+_gnome_application_development/index.html)
* [Hardened Linux From Scratch](http://www.linuxfromscratch.org/hlfs/download.html)
* [Learn Enough Command Line to Be Dangerous](http://www.learnenough.com/command-line) - Michael Hartl
* [Learning Debian GNU/Linux](http://oreilly.com/openbook/debian/book/index.html)
* [Linux 101 Hacks](http://thegeekstuff.s3.amazonaws.com/files/linux-101-hacks.zip) (PDF) - Ramesh Natarajan
* [Linux Administrator's Security Guide](http://www.linuxtopia.org/online_books/linux_administrators_security_guide/index.html)
* [Linux Advanced Routing & Traffic Control HOWTO](http://lartc.org/)
* [Linux Compute Clusters](http://linuxclusters.com/compute_clusters.html)
* [Linux Device Drivers, 2nd Edition](http://www.xml.com/ldd/chapter/book/index.html)
* [Linux Device Drivers, Third Edition](http://lwn.net/Kernel/LDD3/) by Jonathan Corbet, Alessandro Rubini, and Greg Kroah-Hartman
* [Linux from Scratch](http://www.linuxfromscratch.org/lfs/view/stable/)
* [Linux Kernel in a Nutshell](http://www.kroah.com/lkn/)
* [Linux Newbie Administrator Guide](http://lnag.sourceforge.net/)
* [Linux Security for Beginners](http://www.linuxtopia.org/LinuxSecurity/index.html)
* [Linux Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/linux) (PDF, Kindle) *(Just fill the fields with any values)*
* [OpenVZ Linux virtualization](http://download.openvz.org/doc/OpenVZ-Users-Guide.pdf) (PDF)
* [Programming and Using Linux Sound - in depth](http://jan.newmarch.name/LinuxSound/index.html)
* [Red Hat Enterprise Linux 6 Essentials](http://www.techotopia.com/index.php/Red_Hat_Enterprise_Linux_6_Essentials)
* [Secure Programming for Linux and Unix](http://www.dwheeler.com/secure-programs/Secure-Programs-HOWTO.html)
* [The Debian Administrator's Handbook](http://debian-handbook.info/)
* [The Linux Command Line](http://linuxcommand.org/tlcl.php) (PDF)
* [The Linux Development Platform](http://www.informit.com/content/downloads/perens/0130091154.pdf) (PDF)
* [The Linux Kernel Module Programming Guide](http://tldp.org/LDP/lkmpg/2.6/html/)
* [The Linux System Administrator's Guide](http://www.tldp.org/LDP/sag/html/index.html)
* [The Python GTK+ 3 Tutorial](http://python-gtk-3-tutorial.readthedocs.org/en/latest/)
* [Ubuntu Pocket Guide and Reference](http://www.ubuntupocketguide.com/index_main.html)
* [Ubuntu Server Guide](https://help.ubuntu.com/14.04/serverguide/serverguide.pdf)
* [Upstart Intro, Cookbook and Best Practises](http://upstart.ubuntu.com/cookbook/)
* [What Every Programmer Should Know About Memory](http://www.akkadia.org/drepper/cpumemory.pdf) (PDF)

### Lisp
* [Basic Lisp Techniques](http://www.franz.com/resources/educational_resources/cooper.book.pdf) - David J. Cooper, Jr.
* [Casting Spels in Lisp](http://www.lisperati.com/casting.html)
* [Common Lisp Quick Reference](http://clqr.boundp.org/)
* [Common Lisp the Language, 2nd Edition](http://www.cs.cmu.edu/Groups/AI/html/cltl/mirrors.html)
* [Common Lisp: A Gentle Introduction to Symbolic Computation](http://www.cs.cmu.edu/~dst/LispBook/) - David S. Touretzky
* [Common Lisp: An Interactive Approach](http://www.cse.buffalo.edu/~shapiro/Commonlisp/) - Stuart C. Shapiro
* [Google's Common Lisp Style Guide](http://google-styleguide.googlecode.com/svn/trunk/lispguide.xml)
* [Interpreting LISP](http://www.civilized.com/files/lispbook.pdf) - Gary D. Knott
* [Learn Lisp The Hard Way](http://learnlispthehardway.org/book/) - Colin J.E. Lupton
* [Let Over Lambda - 50 Years of Lisp](http://letoverlambda.com/index.cl/toc)
* [Lisp Hackers: Interviews with 100x More Productive Programmers](https://leanpub.com/lisphackers) - Vsevolod Dyomkin
* [Lisp Koans](https://github.com/google/lisp-koans)
* [Lisp Web Tales](https://leanpub.com/lispwebtales/purchases/new)
* [Natural Language Processing in Lisp](http://www.informatics.susx.ac.uk/research/groups/nlp/gazdar/nlp-in-lisp/index.html)
* [On Lisp](http://www.paulgraham.com/onlisp.html)
* [Practical Common Lisp](http://www.gigamonkeys.com/book/)
* [Sketchy LISP](http://www.bcl.hamilton.ie/~nmh/t3x.org/zzz/) - Nils Holm
* [Structure and Interpretation of Computer Programs](http://mitpress.mit.edu/sicp/)
* [Successful Lisp: How to Understand and Use Common Lisp](http://psg.com/~dlamkins/sl/) - David Lamkins
* [The Evolution of Lisp](http://www.dreamsongs.com/Files/HOPL2-Uncut.pdf) - Guy L. Steele Jr., Richard P. Gabriel


### Lua
* [Lua 5.1 Reference Manual](http://www.lua.org/manual/5.1/)
* [Programming In Lua](http://www.lua.org/pil/) (for version 5)
* [Programming Gems](http://www.lua.org/gems/)
* [Wikibook](http://en.wikibooks.org/wiki/Lua_Programming)


### Markdown
* [Learn Markdown](http://www.gitbook.io/book/gitbookio/markdown) (PDF) (EPUB) (MOBI) - GitBookIO, Sammy P., Aaron O.


### Mathematica
* [Basics of Algebra, Topology, and Differential Calculus](http://www.cis.upenn.edu/~jean/math-basics.pdf)
* [Mathematica® programming: an advanced introduction by Leonid Shifrin](http://www.mathprogramming-intro.org/)
* [Stephen Wolfram's The Mathematica Book](http://reference.wolfram.com/legacy/v5_2/)
* [Vector Math for 3d Computer Graphics](http://chortle.ccsu.edu/VectorLessons/index.html)
* [Wolfram Mathematica Tutorial Collection](http://www.wolfram.com/learningcenter/tutorialcollection/)


### MATLAB
* [An Interactive Introduction to MATLAB](http://www.science.smith.edu/~jcardell/Courses/EGR326/Intro-to-MATLAB.pdf)
* [An Introduction to MATLAB](http://www.maths.dundee.ac.uk/ftp/na-reports/MatlabNotes.pdf)
* [Applications of MATLAB in Science and Engineering](http://www.intechopen.com/books/applications-of-matlab-in-science-and-engineering)
* [Experiments with MATLAB](http://www.mathworks.com/moler/exm/index.html)
* [Freshman Engineering Problem Solving with MATLAB](http://cnx.org/featureContent/mfiles)
* [Interactive Tutorials for MATLAB, Simulink, Signal Processing, Controls, and Computational Mathematics](http://www.mathworks.com/tutorials)
* [MATLAB - A Fundamental Tool for Scientific Computing and Engineering Applications - Volume 1](http://www.intechopen.com/books/matlab-a-fundamental-tool-for-scientific-computing-and-engineering-applications-volume-1)
* [MATLAB - A Ubiquitous Tool for the Practical Engineer](http://www.intechopen.com/books/matlab-a-ubiquitous-tool-for-the-practical-engineer)
* [MATLAB for Engineers: Applications in Control, Electrical Engineering, IT and Robotics](http://www.intechopen.com/books/matlab-for-engineers-applications-in-control-electrical-engineering-it-and-robotics)
* [MATLAB Programming](http://en.wikibooks.org/wiki/MATLAB_Programming)
* [MATLAB Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/matlab) (PDF, Kindle) *(Just fill the fields with any values)*
* [Numerical Computing with MATLAB](http://www.mathworks.com/moler/index_ncm.html)
* [Physical Modeling in MATLAB](http://greenteapress.com/matlab/index.html) - Alan B. Downey


### Maven
* [Developing with Eclipse and Maven](http://www.sonatype.com/books/m2eclipse-book/reference/)
* [Maven by Example](http://www.sonatype.com/books/mvnex-book/reference/public-book.html)
* [Maven: The Complete Reference](http://www.sonatype.com/books/mvnref-book/reference/public-book.html)
* [Repository Management with Nexus](http://www.sonatype.com/books/nexus-book/reference/)


### Mercurial
* [HGInit - Mercurial Tutorial by Joel Spolsky](http://hginit.com/)
* [Mercurial: The Definitive Guide](http://hgbook.red-bean.com/) -


### Mercury
* [The Mercury Users' Guide](http://www.mercurylang.org/information/doc-release/user_guide.pdf) (PDF)


### MySQL
* [MySQL Essentials](http://www.techotopia.com/index.php/MySQL_Essentials)
* [MySQL Tutorial Excerpt](http://downloads.mysql.com/docs/mysql-tutorial-excerpt-5.1-en.pdf)


### .NET Framework
* [Charles Petzold's .NET Book Zero](http://www.charlespetzold.com/dotnet/index.html)
* [Entity Framework](http://weblogs.asp.net/zeeshanhirani/archive/2008/12/05/my-christmas-present-to-the-entity-framework-community.aspx)
* [Game Creation with XNA](http://en.wikibooks.org/wiki/Game_Creation_with_XNA)
* [Moving to Microsoft Visual Studio 2010](http://blogs.msdn.com/b/microsoft_press/archive/2010/09/13/free-ebook-moving-to-microsoft-visual-studio-2010.aspx)
* [.NET for Visual FoxPro Developers](http://foxcentral.net/microsoft/NETforVFPDevelopers.htm)
* [.NET Performance Testing and Optimization - The Complete Guide](http://download.red-gate.com/ebooks/DotNet/Perf_Test_and_opt_eBook.zip) *(RedGate, By Paul Glavich and Chris Farrell)*
* [Practical Performance Profiling: Improving the efficiency of .NET code](http://www.red-gate.com/products/dotnet-development/ants-performance-profiler/entrypage/practical-performance-profiling) *(RedGate, By Jean-Philippe Gouigoux)*
* [Under the Hood of .NET Memory Management](http://download.red-gate.com/ebooks/DotNet/Under_the_Hood_of_.NET_Management.pdf) (PDF) *(RedGate, By Chris Farrell and Nick Harrison)*
* [Visual Studio .NET Tips and Tricks](http://www.infoq.com/minibooks/vsnettt) (VS 2003-2005 only)


### Neo4J
* [Graph Databases](http://info.neotechnology.com/rs/neotechnology/images/GraphDatabases.pdf) (PDF)


### NoSQL
* [CouchDB: The Definitive Guide](http://books.couchdb.org/relax/)
* [Extracting Data from NoSQL Databases: A Step towards Interactive Visual Analysis of NoSQL Data](http://publications.lib.chalmers.se/records/fulltext/155048.pdf) - Petter Nasholm
* [Graph Databases](http://graphdatabases.com/)
* [MongoDB Koans](https://github.com/chicagoruby/MongoDB_Koans)
* [MongoDB Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/mongodb) (PDF, Kindle) *(Just fill the fields with any values)*
* [NoSQL Databases](http://www.christof-strauch.de/nosqldbs.pdf) - Christof Strauch
* [The Little MongoDB Book](http://openmymind.net/2011/3/28/The-Little-MongoDB-Book)
* [The Little Redis Book](http://openmymind.net/2012/1/23/The-Little-Redis-Book/)
* [The Little Riak Book](http://littleriakbook.com/)


### Oberon
* [Object-Oriented Programming in Oberon-2](http://ssw.jku.at/Research/Books/Oberon2.pdf) (PDF)
* [Programming in Oberon](http://www-old.oberon.ethz.ch/WirthPubl/ProgInOberon.pdf) (PDF)


### Objective-C
* [Google's Objective-C Style Guide](http://google-styleguide.googlecode.com/svn/trunk/objcguide.xml)
* [Object-Oriented Programming with Objective-C](http://developer.apple.com/library/mac/documentation/Cocoa/Conceptual/OOP_ObjC/OOP_ObjC.pdf) (PDF)
* [Objective-C Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/objective-c) (PDF, Kindle) *(Just fill the fields with any values)*
* [Programming With Objective-C](https://developer.apple.com/library/mac/documentation/Cocoa/Conceptual/ProgrammingWithObjectiveC/ProgrammingWithObjectiveC.pdf) (PDF)
* [Try Objective-C Book](http://tryobjectivec.codeschool.com/)


### OCaml
* [Developing Applications With Objective Caml](http://caml.inria.fr/pub/docs/oreilly-book/)
* [Introduction to Objective Caml](http://courses.cms.caltech.edu/cs134/cs134b/book.pdf) (PDF)
* [Objective Caml for Scientists (first chapter only)](http://www.ffconsultancy.com/products/ocaml_for_scientists/chapter1.html)
* [Real World OCaml](https://realworldocaml.org/v1/en/html/)
* [Think OCaml](http://greenteapress.com/thinkocaml/index.html) - Allen B. Downey and Nicholas Monje
* [Unix System Programming in OCaml](http://ocamlunix.forge.ocamlcore.org/)
* [Using, Understanding, and Unraveling The OCaml Language: From Practice to Theory and vice versa](http://pauillac.inria.fr/~remy/cours/appsem/) - Didier Rémy


### Octave
* [Octave Programming](http://en.wikibooks.org/wiki/Octave_Programming_Tutorial)


### OpenGL ES
* [iPhone 3D Programming - Developing Graphical Applications with OpenGL ES](http://chimera.labs.oreilly.com/books/1234000001814/index.html) - Philip Rideout

### OpenMP
* [A Guide To OpenMP](http://www2.cs.uh.edu/~estrabd/openmp-combined.pdf) (PDF)
* [OpenMP Application Programming Interface Standard Version 4.0](http://www.openmp.org/mp-documents/OpenMP4.0.0.pdf) (PDF)

### OpenSCAD
* [OpenSCAD User Manual](http://en.wikibooks.org/wiki/OpenSCAD_User_Manual)


### Oracle PL/SQL


### Oracle Server
* [Oracle's Guides and Manuals](http://tahiti.oracle.com/)


### Parrot / Perl 6
* [Perl 6 Programming](https://en.wikibooks.org/wiki/Perl_6_Programming)
* [Using Perl 6](http://github.com/perl6/book/) (work in progress)


### PC-BSD
* [PC-BSD® Users Handbook](http://wiki.pcbsd.org/index.php/PC-BSD%C2%AE_Users_Handbook)


### Perl
* [Beginning Perl](http://www.perl.org/books/beginning-perl/)
* [Data Munging with Perl](http://perlhacks.com/dmp.pdf) (PDF)
* [Embedding Perl in HTML with Mason](http://www.masonbook.com/book/)
* [Essential Perl](http://cslibrary.stanford.edu/108/EssentialPerl.pdf) (PDF)
* [Exploring Programming Language Architecture in Perl](http://www.billhails.net/Book/)
* [Extreme Perl](http://www.extremeperl.org/bk/home)
* [Higher-Order Perl](http://hop.perl.plover.com/book/)
* [Impatient Perl](http://www.perl.org/books/impatient-perl/)
* [Learning Perl The Hard Way](http://www.greenteapress.com/perl/)
* [Mastering Perl](http://chimera.labs.oreilly.com/books/1234000001527) - brian d foy
* [Modern Perl 5](http://www.onyxneon.com/books/modern_perl/index.html)
* [Perl & LWP](http://lwp.interglacial.com/index.html)
* [Perl 5 Internals](http://www.faqs.org/docs/perl5int/)
* [Perl for the Web](http://www.globalspin.com/thebook/)
* [Perl Training Australia - Course Notes](http://perltraining.com.au/notes.html)
* [Plack Handbook](http://handbook.plackperl.org/)
* [Practical mod_perl](http://modperlbook.org/) - Stas Bekman, Eric Cholet
* [SDL::Manual Writing Games in Perl](https://github.com/PerlGameDev/SDL_Manual)
* [Template Toolkit Documentation](http://template-toolkit.org/docs/index.html)
* [The DBIx-Class Book](https://github.com/castaway/dbix-class-book)
* [The PDL Book](http://sourceforge.net/projects/pdl/files/PDL_2013/PDL-Book/PDL-Book-20130322.pdf/download) (PDF)
* [Web Client Programming with Perl](http://oreilly.com/openbook/webclient/)


### PHP
* CakePHP Framework
    * [CakePHP Cookbook 2.x](http://book.cakephp.org/2.0/_downloads/en/CakePHPCookbook.pdf)
* Drupal Framework
    * Drupal 7
        * [Master Drupal in 7 hours](http://dl.dropboxusercontent.com/u/54624702/Master%20Drupal%20in%207%20hours_v1.1.pdf) (PDF)
        * [The Tiny Book of Rules](https://drupal.org/files/tiny-book-of-rules.pdf) (PDF)
    * Drupal 8
* Laravel Framework
    * [Laravel 4 Official Documentation. Synced Daily](https://leanpub.com/l4)
    * [Laravel: Code Bright](http://daylerees.com/codebright)
    * [Official Documentation (Offline Version)](https://leanpub.com/l4-offline-doc)
* [PHP 5 Power Programming](http://www.informit.com/content/images/013147149X/downloads/013147149X_book.pdf)
* [PHP Best Practices](https://phpbestpractices.org/)
* [PHP Essentials](http://www.techotopia.com/index.php/PHP_Essentials)
* [PHP Internals Book](http://www.phpinternalsbook.com/)
* [PHP Programming](http://en.wikibooks.org/wiki/PHP_Programming)
* [PHP Security Guide](http://phpsec.org/projects/guide/)
* [PHP: The Right Way](http://www.phptherightway.com/)
* [Practical PHP Programming](http://www.tuxradar.com/practicalphp) (wiki containing O'Reilly's *PHP In a Nutshell*)
* [Practical PHP Testing](http://www.giorgiosironi.com/2009/12/practical-php-testing-is-here.html)
* [Survive The Deep End: PHP Security](https://phpsecurity.readthedocs.org/en/latest/)
* [Symfony2](http://symfony.com/doc/current/book/index.html)
* [Using Libsodium in PHP Projects](https://paragonie.com/book/pecl-libsodium) - libsodium PHP extension for modern, secure, and fast cryptography


### PicoLisp
* [PicoLisp by Example](http://www.scribd.com/doc/103733857/PicoLisp-by-Example)
* [PicoLisp Works](http://www.scribd.com/doc/103732688/PicoLisp-Works)


### PostgreSQL
* [Postgres Succinctly](http://www.syncfusion.com/resources/techportal/ebooks/postgres) (PDF, Kindle) *(Just fill the fields with any values)*
* [Practical PostgreSQL](http://www.commandprompt.com/ppbook/)


### PowerShell
* [Layman’s Guide to PowerShell 2.0 remoting](http://www.ravichaganti.com/blog/wp-content/plugins/download-monitor/download.php?id=22) (PDF)
* [Mastering PowerShell](http://powershell.com/cs/blogs/ebook/)
* [PowerShell 2.0 – One CMDLET At A Time](http://www.jonathanmedd.net/wp-content/uploads/2010/09/PowerShell_2_One_Cmdlet_at_a_Time.pdf) (PDF)
* [PowerShell Succinctly, Syncfusion](https://www.syncfusion.com/resources/techportal/ebooks/powershell) (PDF, Kindle) *(Just fill the fields with any values)*


### Processing
* [The Nature of Code: Simulating Natural Systems with Processing](http://natureofcode.com/book/)


### Prolog
* [Adventure in Prolog](http://www.amzi.com/AdventureInProlog/advfrtop.htm)
* [Applications of Prolog](http://bookboon.com/int/student/it/applications-of-prolog)
* [Building Expert Systems in Prolog](http://www.amzi.com/ExpertSystemsInProlog/)
* [Coding Guidelines for Prolog](http://arxiv.org/abs/0911.2899) - Michael A. Covington, Roberto Bagnara, Richard A. O'Keefe, Jan Wielemaker, Simon Price
* [Concise Intro to Prolog](http://www.cis.upenn.edu/~matuszek/Concise%20Guides/Concise%20Prolog.html)
* [GNU Prolog Manual](http://www.gprolog.org/manual/gprolog.pdf) (PDF)
* [Introduction to Prolog for Mathematicians](http://www.j-paine.org/prolog/mathnotes/files/pms/pms.html)
* [Learn Prolog Now!](http://www.learnprolognow.org/)
* [Logic, Programming and Prolog (2ed)](http://www.ida.liu.se/~ulfni/lpp/)
* [Natural Language Processing Techniques in Prolog](http://cs.union.edu/~striegnk/courses/nlp-with-prolog/html/)
* [Prolog and Natural-Language Analysis](http://www.mtome.com/Publications/PNLA/pnla-digital.html) - Fernando C. N. Pereira, Stuart M. Shieber
* [Prolog Experiments in Discrete Mathematics, Logic, and Computability](http://web.cecs.pdx.edu/~jhein/books/PrologLabBook09.pdf) - James L. Hein
* [Prolog for Programmers](https://sites.google.com/site/prologforprogrammers/)
* [Prolog Problems](https://sites.google.com/site/prologsite/prolog-problems) - Werner Hett
* [Prolog Programming: A First Course](http://engronline.ee.memphis.edu/deductiveDB/prolog_book.pdf) - Paul Brna
* [Prolog Techniques](http://bookboon.com/int/student/it/prolog-techniques-applications-of-prolog)
* [Prolog Tutorial](http://www.cpp.edu/~jrfisher/www/prolog_tutorial/contents.html)
* [Simply Logical](http://www.cs.bris.ac.uk/~flach/SimplyLogical.html)
* [The First 10 Prolog Programming Contests](http://dtai.cs.kuleuven.be/ppcbook/) - Bart Demoen, Phuong-Lan Nguyen, Tom Schrijvers, Remko Tronçon
* [Warren's Abstract Machine: A Tutorial Reconstruction](http://wambook.sourceforge.net/) - Hassan A¨it-Kaci


#### Constraint Logic Programming (extended Prolog)
* [A Gentle Guide to Constraint Logic Programming via ECLiPSe](http://anclp.pl/)

### PureScript
* [PureScript By Example](http://leanpub.com/purescript/read) - Phil Freeman

### Python
* [A Beginner's Python Tutorial](http://en.wikibooks.org/wiki/A_Beginner%27s_Python_Tutorial)
* [A Bit of Python and Other Things](https://github.com/RafeKettler/magicmethods)
* [A Guide to Python's Magic Methods](https://github.com/RafeKettler/magicmethods) - Rafe Kettler
* [Automate the Boring Stuff](http://automatetheboringstuff.com/chapter0/) - Al Sweigart
* [Biopython](http://biopython.org/DIST/docs/tutorial/Tutorial.pdf)
* [Building Skills in Object-Oriented Design (Python)](http://www.itmaybeahack.com/book/oodesign-python-2.1/latex/BuildingSkillsinOODesign.pdf) (PDF) (2.1.1)
* [Building Skills in Python](http://www.itmaybeahack.com/book/python-2.6/latex/BuildingSkillsinPython.pdf) (PDF) (2.6)
* [Byte of Python](http://www.swaroopch.com/notes/Python) (2.7.x)
* [Code Like a Pythonista: Idiomatic Python](http://python.net/~goodger/projects/pycon/2007/idiomatic/handout.html)
* [CodeCademy Python](http://www.codecademy.com/tracks/python)
* [Composing Programs](http://composingprograms.com/) (3.x)
* [Data Structures and Algorithms in Python](http://www.brpreiss.com/books/opus7/html/book.html)
* [Dive into Python 3](http://getpython3.com/diveintopython3/) - Mark Pilgrim (3.0)
* [Dive into Python](http://www.diveintopython.net/) - Mark Pilgrim (2.3)
* [Full Stack Python](http://www.fullstackpython.com/)
* [Google's Python Class](https://developers.google.com/edu/python/) (2.4 - 2.x)
* [Google's Python Style Guide](http://google-styleguide.googlecode.com/svn/trunk/pyguide.html)
* [Hacking Secret Cyphers with Python](http://inventwithpython.com/hacking/chapters/) - Al Sweigart (3.3)
* [High Performance Python](http://ianozsvald.com/HighPerformancePythonfromTrainingatEuroPython2011_v0.2.pdf)
* [Hitchhiker's Guide to Python!](http://docs.python-guide.org/en/latest/) (2.6)
* [How to Think Like a Computer Scientist: Learning with Python](http://www.greenteapress.com/thinkpython/thinkCSpy/) - Allen B. Downey, Jeff Elkner and Chris Meyers (2.4)
	* [How to Think Like a Computer Scientist: Learning with Python, Interactive Edition](http://interactivepython.org/courselib/static/thinkcspy/index.html) (3.2)
* [Intermediate Python](http://book.pythontips.com/en/latest/index.html#) - Muhammad Yasoob Ullah Khalid (1st edition)
* [Introduction to Programming Using Python](http://python-ebook.blogspot.com) - Cody Jackson (1st edition) (2.3)
* [Introduction to Programming with Python](http://opentechschool.github.io/python-beginners/en/) (3.3)
* [Introduction to python](http://kracekumar.com/post/71171551647/introduction-to-python) - Kracekumar (2.7.3)
* [Invent Your Own Computer Games With Python](http://inventwithpython.com/chapters/) - Al Sweigart (3.1)
* [Learn Python in Y minutes](http://learnxinyminutes.com/docs/python/)
* [Learn Python The Hard Way](http://learnpythonthehardway.org/book/) (2.5 - 2.6)
* [Learn Python, Break Python](http://learnpythonbreakpython.com)
* [Learn to Program Using Python](https://www.ida.liu.se/~732A47/literature/PythonBook.pdf) - Cody Jackson
* [Learning to Program with Python](http://python.cs.southern.edu/pythonbook/pythonbook.pdf) - Richard L. Halterman (PDF) (3.2)
* [Learning to Program](http://www.freenetpages.co.uk/hp/alan.gauld/) (2.3)
* [Lectures on scientific computing with python](https://github.com/jrjohansson/scientific-python-lectures) - J.R. Johansson (2.7)
* [Making Games with Python & Pygame](http://inventwithpython.com/pygame/chapters/) - Al Sweigart (2.7)
* [Modeling Creativity: Case Studies in Python](http://www.clips.ua.ac.be/sites/default/files/modeling-creativity.pdf) - Tom D. De Smedt (PDF)
* [Natural Language Processing with Python](http://www.nltk.org/book) (2.5)
* [Non-Programmer's Tutorial for Python 2.6](http://en.wikibooks.org/wiki/Non-Programmer%27s_Tutorial_for_Python_2.6) (2.6)
* [Non-Programmer's Tutorial for Python 3](http://en.wikibooks.org/wiki/Non-Programmer%27s_Tutorial_for_Python_3) (3.3)
* [Porting to Python 3: An In-Depth Guide](http://python3porting.com/) (2.6 - 2.x & 3.1 - 3.x)
* [Practical Programming in Python](https://launchpadlibrarian.net/165489933/PracticalProgrammingPython2014.pdf) - Jeffrey Elkner
* [Problem Solving with Algorithms and Data Structure using Python](http://interactivepython.org/runestone/static/pythonds/index.html) - Bradley N. Miller and David L. Ranum
* [Program Arcade Games With Python And Pygame](http://programarcadegames.com/) (3.3)
* [Programming Computer Vision with Python](http://programmingcomputervision.com/downloads/ProgrammingComputerVision_CCdraft.pdf)
* [Python 2.7 quick reference](http://infohost.nmt.edu/tcc/help/pubs/python/web/) - New Mexico Tech (2.7)
* [Python Algorithms](http://kysmykseka.net/koti/wizardry/Programming/Python/Apress%20-%20Python%20Algorithms%20Mastering%20Basic%20Algorithms%20in%20the%20Python%20Language.pdf) (PDF)
* [Python Bibliotheca](http://openbookproject.net/pybiblio/)
* [Python Cookbook](http://chimera.labs.oreilly.com/books/1230000000393/index.html) - David Beazley
* [Python for Econometrics](http://www.kevinsheppard.com/images/0/09/Python_introduction.pdf) - Kevin Sheppard (2.7.5)
* [Python for Fun](http://www.openbookproject.net/py4fun/)
* [Python for Informatics: Exploring Information](http://www.pythonlearn.com/book.php) (2.7.5)
* [Python for you and me](http://pymbook.readthedocs.org/en/latest/) (2.7.3)
* [Python for you and me](http://pymbook.readthedocs.org/en/py3/) (3.x)
* [Python Guide](http://docs.python-guide.org/en/latest/)
* [Python Idioms](http://safehammad.com/downloads/python-idioms-2014-01-16.pdf) (PDF)
* [Python in Hydrology](http://www.greenteapress.com/pythonhydro/pythonhydro.html) - Sat Kumar Tomer
* [Python Koans](https://github.com/gregmalcolm/python_koans) (2.7 or 3.x)
* [Python Module of the Week](http://pymotw.com/2/)
* [Python Official Documentation](https://docs.python.org/2/download.html) (PDF, HTML, TEXT) (2.x)
* [Python Official Documentation](https://docs.python.org/3/download.html) (PDF, EPUB, HTML, TEXT) (3.x)
* [Python Practice Book](http://anandology.com/python-practice-book/index.html) (2.7.1)
* [Python Practice Projects](http://www.pythonpracticeprojects.com)
* [Python Programming](http://upload.wikimedia.org/wikipedia/commons/9/91/Python_Programming.pdf) (PDF) (2.6)
* [Python Scientific Lecture Notes](http://scipy-lectures.github.io/)
* [Python Scripting for Computational Science](http://info.baustatik.uni-due.de/Lehre/CM-AOS/Scripts/Abaqus/Python%20Scripting%20for%20Computational%20Science.pdf) - Hans Petter Langtangen
* [Python Standard Library](http://effbot.org/librarybook/) - Fredrik Lundh
* [Snake Wrangling For Kids](http://www.briggs.net.nz/snake-wrangling-for-kids.html) (3.x)
* [Test-Driven Web Development with Python](http://chimera.labs.oreilly.com/books/1234000000754/index.html) (3.3 - 3.x)
* [Text Processing in Python](http://gnosis.cx/TPiP/) - David Mertz (2.3 - 2.x)
* [The Little Book of Python Anti-Patterns](http://docs.quantifiedcode.com/python-anti-patterns/) ([Source](https://github.com/quantifiedcode/python-anti-patterns))
* [The Programming Historian](http://niche-canada.org/research/niche-digital-infrastructure-project/the-programming-historian/) - William J. Turkel, Adam Crymble and Alan MacEachern
* [The Python Ecosystem: An Introduction](http://mirnazim.org/writings/python-ecosystem-introduction/)
* [Think Python](http://www.greenteapress.com/thinkpython/) - Allen B. Downey (2.x & 3.0)
* [Web2py: Complete Reference Manual, 6th Edition (pre-release)](http://web2py.com/book) (2.5 - 2.x)
* [Welcome to Problem Solving with Algorithms and Data Structures](http://interactivepython.org/runestone/static/pythonds/index.html) - Brad Miller and David Ranum
* [Wikibooks: Python Programming](http://en.wikibooks.org/wiki/Python_Programming) (2.7)


#### Django
* [Django by Example for Django 1.5](http://lightbird.net/dbe2/) (1.5)
* [Django by Example](http://www.lightbird.net/dbe/) (1.2)
* [Django Official Documentation](https://media.readthedocs.org/pdf/django/1.5.x/django.pdf) (PDF) (1.5)
* [Django Official Documentation](https://media.readthedocs.org/pdf/django/1.7.x/django.pdf) (PDF) (1.7)
* [Djen of Django](http://agiliq.com/books/djenofdjango/)
* [Effective Django](http://effectivedjango.com/) (1.5)
* [Getting started with Django](http://gettingstartedwithdjango.com/) (video)
* [Tango With Django](http://www.tangowithdjango.com/) (1.5)
* [Test-Driven Web Development with Python](http://chimera.labs.oreilly.com/books/1234000000754/index.html) (1.8)
* [The Django book](http://www.djangobook.com/en/2.0/) (1.4 but mostly 1.0)


#### Flask
* [Explore Flask](http://exploreflask.com/) - Robert Picard
* [Flask Microframework](http://flask.pocoo.org/docs/tutorial/)
* [The Flask Mega-Tutorial](http://blog.miguelgrinberg.com/post/the-flask-mega-tutorial-part-i-hello-world) - Miguel Grinberg (0.9)


#### Kivy
* [Kivy Programming Guide](http://kivy.org/docs/pdf/Kivy-latest.pdf)


#### Pandas
* [Learn Pandas](https://bitbucket.org/hrojas/learn-pandas) - Hernan Rojas (0.13.0)


#### Pyramid
* [Pyramid for humans](http://docs.pylonsproject.org/projects/pyramid_tutorials/en/latest/humans/index.html)


### QML
* [Qt5 Cadaques](http://qmlbook.org/) (HTML, PDF, ePub) (work in progress) - Juergen Bocklage-Ryannel and Johan Thelin


### R
* [Advanced R Programming](http://adv-r.had.co.nz/) - Hadley Wickham
* [Introduction to Probability and Statistics Using R](http://cran.r-project.org/web/packages/IPSUR/vignettes/IPSUR.pdf) (PDF) - G. Jay Kerns
* [Learning Statistics with R](http://health.adelaide.edu.au/psychology/ccs/teaching/lsr/) - Daniel Navarro
* [learnR](https://github.com/renkun-ken/learnR) - (Work in Progress) - Kun Ren
* [Practical Regression and Anova using R](http://cran.r-project.org/doc/contrib/Faraway-PRA.pdf) (PDF) - Julian J. Faraway
* [R by example](http://www.mayin.org/ajayshah/KB/R/index.html)
* [R for spatial analysis](http://www.columbia.edu/~cjd11/charles_dimaggio/DIRE/resources/spatialEpiBook.pdf) (PDF)
* [R language for Programmers](http://www.johndcook.com/R_language_for_programmers.html) - John D. Cook
* [R packages](http://r-pkgs.had.co.nz) - Hadley Wickham
* [R practicals](http://www.columbia.edu/~cjd11/charles_dimaggio/DIRE/resources/R/practicalsBookNoAns.pdf) (PDF)
* [R Programming](http://en.wikibooks.org/wiki/R_Programming)
* [R Programming for Data Science](https://leanpub.com/rprogramming) (Needs valid email)
* [R Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/rsuccinctly) (PDF, Kindle) *(Just fill the fields with any values)*
* [The R Inferno](http://www.burns-stat.com/pages/Tutor/R_inferno.pdf) (PDF) - Patrick Burns
* [The R Language](http://stat.ethz.ch/R-manual/R-patched/doc/html/)
* [The R Manuals](http://cran.r-project.org/manuals.html)


### Racket
* [How to Design Programs 2e](http://www.ccs.neu.edu/home/matthias/HtDP2e/)
* [Programming Languages: Application and Interpretation](http://cs.brown.edu/courses/cs173/2012/book/index.html)
* [Realm of Racket](http://it-ebooks.info/book/2628/)
* [The Racket Guide](http://docs.racket-lang.org/guide/index.html)


### Raspberry Pi
* [Raspberry Pi Users Guide](http://www.cs.unca.edu/~bruce/Fall14/360/RPiUsersGuide.pdf) (PDF) - Eben Upton
* [Raspberry Pi: Measure, Record, Explore](https://leanpub.com/RPiMRE)

### REBOL
* [Learn REBOL](http://www.lulu.com/shop/nick-antonaccio/learn-rebol/ebook/product-17383182.html) - Nick Antonaccio


### Ruby
* [A community-driven Ruby style guide](https://github.com/bbatsov/ruby-style-guide)
* [CodeCademy Ruby](http://www.codecademy.com/tracks/ruby)
* [Developing Games With Ruby](https://leanpub.com/developing-games-with-ruby/read)
* [I Love Ruby](http://goo.gl/1qrMUN)
* [Just Enough Ruby to Get By](http://jasonkim.ca/projects/just_enough_ruby_to_get_by)
* [Learn Ruby the hard way](http://ruby.learncodethehardway.org/book/)
* [Learn to Program, by Chris Pine](http://pine.fm/LearnToProgram/)
* [Mr. Neighborly's Humble Little Ruby Book](http://www.humblelittlerubybook.com/)
* [Practicing Ruby](https://github.com/elm-city-craftworks/practicing-ruby-manuscripts)
* [Programming Ruby](http://www.ruby-doc.org/docs/ProgrammingRuby/)
* [Ruby Essentials](http://www.techotopia.com/index.php/Ruby_Essentials)
* [Ruby Hacking Guide](http://ruby-hacking-guide.github.io/)
* [Ruby in Twenty Minutes](https://www.ruby-lang.org/en/documentation/quickstart/)
* [Ruby Koans](http://www.rubykoans.com/)
* [Ruby Learning](http://rubylearning.com/)
* [Ruby Programming](http://www.linuxtopia.org/online_books/programming_books/ruby_tutorial/)
* [Ruby User's Guide](http://www.rubyist.net/~slagell/ruby/)
* [The Bastards Book of Ruby](http://ruby.bastardsbook.com/)
* [The Unofficial Ruby Usage Guide (at Google)](http://www.caliban.org/ruby/rubyguide.shtml) - Ian Macdonald
* [Why's (Poignant) Guide to Ruby](http://mislav.uniqpath.com/poignant-guide/) ([mirror](http://www.scribd.com/doc/2236084/Whys-Poignant-Guide-to-Ruby))


#### RSpec
* [Better Specs (RSpec Guidelines with Ruby)](http://betterspecs.org)


#### Sinatra
* [Sinatra Book](https://github.com/sinatra/sinatra-book)


#### Ruby on Rails
* [A community-driven Rails style guide](https://github.com/bbatsov/rails-style-guide)
* [Building REST APIs with Rails](http://apionrails.icalialabs.com/book)
* [Kestrels, Quirky Birds, and Hopeless Egocentricity](https://leanpub.com/combinators/read)
* [Learn Ruby on Rails as You Modify a Craigslist Clone](http://www.thinkful.com/learn/ruby-on-rails-tutorial/)
* [Objects on Rails](http://objectsonrails.com)
* [Rails Girls Guides](http://guides.railsgirls.com)
* [Ruby on Rails 3.2 - Step by Step](http://www.xyzpub.com/en/ruby-on-rails/3.2/)
* [Ruby on Rails 4.0 Guide](http://www.xyzpub.com/en/ruby-on-rails/4.0/)
* [Ruby on Rails Guides](http://guides.rubyonrails.org)
* [Ruby on Rails Tutorial: Learn Rails By Example](https://www.railstutorial.org/book/)
* [Upgrading to Rails 4](https://github.com/alindeman/upgradingtorails4)


### Rust
* [Rust by Example](http://rustbyexample.com/)
* [Rust for Rubyists](http://www.rustforrubyists.com/book/index.html)
* [The Rust Programming Language](http://doc.rust-lang.org/book/)
* [Why Rust?](http://www.oreilly.com/programming/free/files/why-rust.pdf)


### Sage
* [Sage for Power Users](http://modular.math.washington.edu/books/sagebook/sagebook.pdf) (PDF) - William
* [The Sage Manuals](http://sagemath.org/doc/)


### Scala
* [A Scala Tutorial for Java programmers](http://www.scala-lang.org/docu/files/ScalaTutorial.pdf) (PDF)
* [Another tour of Scala](http://naildrivin5.com/scalatour)
* [EAI Patterns with Actor Model](https://github.com/alexanderfefelov/eai-patterns-with-actor-model) - Vaughn Vernon
* [Effective Scala](http://twitter.github.com/effectivescala/)
* [Learning Scalaz](http://eed3si9n.com/learning-scalaz/)
* [Pro Scala: Monadic Design Patterns for the Web](http://github.com/leithaus/XTrace/tree/monadic/src/main/book/content/)
* [Program Transformation in Scala](http://homepages.cwi.nl/~ai/MScThesis-A-Izmaylova.pdf) - Anastasia Izmaylova
* [Programming in Scala, First Edition](http://www.artima.com/pins1ed/)
* [S-99: Ninety-Nine Scala Problems](http://aperiodic.net/phil/scala/s-99/) - Phil! Gold
* [Scala & Design Patterns: Exploring Language Expressivity](http://www.scala-lang.org/old/sites/default/files/FrederikThesis.pdf) - Fredrik Skeel Løkke
* [Scala By Example](http://www.scala-lang.org/docu/files/ScalaByExample.pdf) (PDF)
* [Scala Cookbook: Bonus Chapters](http://examples.oreilly.com/9781449339616-files/Scala_Cookbook_bonus_chapters.pdf) - Alvin Alexander
* [Scala for Perl 5 Programmers](https://github.com/garu/scala-for-perl5-programmers) - Breno G. de Oliveira
* [Scala for the Impatient (A1 Scala Level chapters)](http://typesafe.com/resources/book/scala-for-the-impatient) - Cay S. Horstmann
* [Scala School by Twitter](http://twitter.github.io/scala_school/)
* [Scala Tutorial](http://www.tutorialspoint.com/scala/scala_tutorial.pdf)
* [tetrix in Scala](http://eed3si9n.com/tetrix-in-scala-html5-book)
* [The Neophyte's Guide to Scala](http://danielwestheide.com/scala/neophytes.html) - Daniel Westheide
* [Xtrace](http://github.com/leithaus/XTrace/tree/monadic/src/main/book/content/)


#### Lift
* [Exploring Lift](http://exploring.liftweb.net/) (published earlier as "The Definitive Guide to Lift", [PDF](http://groups.google.com/group/the-lift-book))
* [Lift](http://github.com/tjweir/liftbook)
* [Lift Cookbook](http://chimera.labs.oreilly.com/books/1234000000030/index.html) - Richard Dallaway
* [Simply Lift](http://simply.liftweb.net/Simply_Lift.pdf) - David Pollak


#### Play Scala
* [Play Framework Recipes](http://alvinalexander.com/scala/scala-cookbook-play-framework-recipes-pdf-ebook) - Alvin Alexander


### Scheme
* [An Introduction to Scheme and its Implementation](http://www.cs.rpi.edu/academics/courses/fall00/ai/scheme/reference/schintro-v14/schintro_toc.html)
* [Concrete Abstractions: An Introduction to Computer Science Using Scheme](https://gustavus.edu/+max/concrete-abstractions.html)
* [How to Design Programs](http://htdp.org)
* [Scheme Tutorial](http://www.cs.hut.fi/Studies/T-93.210/schemetutorial/)
* [Simply Scheme: Introducing Computer Science](http://www.cs.berkeley.edu/~bh/ss-toc2.html)
* [Structure and Interpretion of Computer Programs](http://mitpress.mit.edu/sicp/full-text/book/book.html)
* [Teach Yourself Scheme in Fixnum Days](http://www.ccs.neu.edu/home/dorai/t-y-scheme/t-y-scheme.html)
* [The Scheme Programming Language: Edition 3](http://www.scheme.com/tspl3/) - [The Scheme Programming Language: Edition 4](http://www.scheme.com/tspl4/)
* [Write Yourself a Scheme in 48 Hours](http://en.wikibooks.org/wiki/Write_Yourself_a_Scheme_in_48_Hours)


### Scilab
* [Introduction to Scilab](http://forge.scilab.org/index.php/p/docintrotoscilab/downloads/)
* [Programming in Scilab](http://forge.scilab.org/index.php/p/docprogscilab/downloads/)
* [Writing Scilab Extensions](http://forge.scilab.org/index.php/p/docsciextensions/downloads/)


### Scratch
* [Computer Science Concepts in Scratch](http://stwww.weizmann.ac.il/g-cs/scratch/scratch_en.html)


### Sed
* [Sed - An Introduction and Tutorial](http://www.grymoire.com/Unix/Sed.html)


### Smalltalk
* [Computer Programming using GNU Smalltalk](http://www.canol.info/books/computer_programming_using_gnu_smalltalk) (PDF)
* [Dynamic Web Development with Seaside](http://book.seaside.st/book/table-of-contents)
* [Free Online Smalltalk Books](http://stephane.ducasse.free.fr/FreeBooks.html) (meta-list)
* [Pharo by Example](http://pharobyexample.org/) (Smalltalk DE)
* [Squeak By Example](http://www.squeakbyexample.org/) (Smalltalk IDE)


### SQL (implementation agnostic)
* [A Primer on SQL, Second Edition](https://leanpub.com/aprimeronsql)
* [Developing Time-Oriented Database Applications in SQL](http://www.cs.arizona.edu/people/rts/publications.html)
* [Learn SQL The Hard Way](http://sql.learncodethehardway.org/)
* [SQL For Web Nerds](http://philip.greenspun.com/sql/)
* [Use The Index, Luke!: A Guide To SQL Database Performance](http://use-the-index-luke.com/)


### SQL Server
* [Best of SQLServerCentral.com Vol 7](http://www.red-gate.com/community/books/ssc-7.htm) *(RedGate, By SQLServerCentral Authors)
* [Brad's Sure Guide to SQL Server Maintenance Plans](http://www.red-gate.com/community/books/sql-server-maintenance-plans) *(RedGate, By Brad McGehee)*
* [Defensive Database Programming](http://download.red-gate.com/ebooks/SQL/defensive-database-programming.pdf) (PDF) *(RedGate, By Alex Kuznetsov)*
* [How to Become an Exceptional DBA](http://www.red-gate.com/community/books/exceptional-dba-book) *(RedGate, By Brad McGehee)*
* [Inside the SQL Server Query Optimizer](http://www.red-gate.com/products/sql-development/sql-prompt/entrypage/sql-query-optimizer-ebook3) *(RedGate, By Benjamin Nevarez)*
* [Introducing Microsoft SQL Server 2008 R2](http://social.technet.microsoft.com/wiki/contents/articles/11608.e-book-gallery-for-microsoft-technologies.aspx#IntroducingMicrosoftSQLServer2008R2)
* [Introducing Microsoft SQL Server 2012](http://social.technet.microsoft.com/wiki/contents/articles/11608.e-book-gallery-for-microsoft-technologies.aspx#IntroducingMicrosoftSQLServer2012)
* [Introducing Microsoft SQL Server 2014](http://blogs.msdn.com/b/microsoft_press/archive/2014/04/02/free-ebook-introducing-microsoft-sql-server-2014.aspx)
* [Mastering SQL Server Profiler](http://www.red-gate.com/community/books/mastering-sql-server-profiler.htm) *(RedGate, By Brad McGehee)*
* [Performance Tuning with SQL Server Dynamic Management Views](http://www.red-gate.com/community/books/dynamic-management-views.htm) *(RedGate, By Tim Ford and Louis Davidson)*
* [Protecting SQL Server Data](http://www.red-gate.com/community/books/protecting-data.htm) *(RedGate, By John Magnabosco)*
* [SQL Server 2012 Tutorials: Reporting Services](http://social.technet.microsoft.com/wiki/contents/articles/11608.e-book-gallery-for-microsoft-technologies.aspx#SQLServer2012Tutorials%3AReportingServices)
* [SQL Server Backup and Restore](http://www.red-gate.com/community/books/sql-server-backup-and-restore.htm) *(RedGate, By Shawn McGehee)*
* [SQL Server Concurrency: Locking, Blocking and Row Versioning](http://www.red-gate.com/community/books/sql-server-concurrency.htm) *(RedGate, By Kalen Delaney)*
* [SQL Server Execution Plans](http://download.red-gate.com/ebooks/SQL/sql-server-execution-plans.pdf) (PDF) *(RedGate, By Grant Fritchey)*
* [SQL Server Execution Plans, Second Edition](http://download.red-gate.com/ebooks/SQL/eBOOK_SQLServerExecutionPlans_2Ed_G_Fritchey.pdf) (PDF) *(RedGate, By Grant Fritchey)*
* [SQL Server Hardware](http://www.red-gate.com/community/books/sql-server-hardware) *(RedGate, By Glenn Berry)*
* [SQL Server Statistics](http://www.red-gate.com/community/books/sql-server-statistics.htm) *(RedGate, By Holger Schmeling)*
* [SQL Server Stumpers Vol.5](http://www.red-gate.com/community/books/sql-server-stumpers-v5.htm) *(RedGate, By SQLServerCentral Authors)*
* [SQL Server Tacklebox](http://www.red-gate.com/community/books/sql-server-tacklebox) *(RedGate, By Rodney Landrum)*
* [SQL Server Transaction Log Management](http://www.red-gate.com/community/books/sql-server-transaction-log-management) *(RedGate, By Tony Davis and Gail Shaw)*
* [The Art of SQL Server FILESTREAM](http://www.red-gate.com/community/books/art-of-filestream.htm) *(RedGate, By Jacob Sebastian and Sven Aelterman)*
* [Troubleshooting SQL Server: A Guide for the Accidental DBA](http://www.red-gate.com/community/books/accidental-dba) *(RedGate, By Jonathan Kehayias and Ted Krueger)*


### Standard ML
* [Programming in Standard ML '97](http://www.dcs.ed.ac.uk/home/stg/NOTES/) - by Stephen Gilmore, University of Edinburgh
* [Programming in Standard ML, Draft](http://www.cs.cmu.edu/~rwh/smlbook/) - Robert Harper

### Subversion
* [Subversion Version Control](http://www.phptr.com/content/images/0131855182/downloads/Nagel_book.pdf) (PDF)
* [Version Control with Subversion](http://svnbook.red-bean.com/)


### Swift
* [Learn Swift](http://www.swift-tutorial.io/learn-swift)
* [The Swift Programming Language](https://developer.apple.com/library/prerelease/ios/documentation/Swift/Conceptual/Swift_Programming_Language/index.html) (HTML)
* [The Swift Programming Language](https://itunes.apple.com/us/book/swift-programming-language/id881256329?mt=11) (iBook)
* [Using Swift with Cocoa and Objective-C](https://itunes.apple.com/us/book/using-swift-cocoa-objective/id888894773?mt=11) (iBook)

### Tcl
* [Tcl Programming](http://en.wikibooks.org/wiki/Programming%3ATcl) - by Richard.Suchenwirth, et. al.
* [TclWise](http://www.invece.org/tclwise/index.html) - by Salvatore Sanfilippo


### Teradata
* [Teradata Books](http://www.info.teradata.com/)


### TeX
* [Notes On Programming in TeX](http://pgfplots.sourceforge.net/TeX-programming-notes.pdf) (PDF) by Christian Feursänger
* [TeX by Topic, A TeXnician's Reference](http://eijkhout.net/texbytopic/texbytopic.html) - by Victor Eijkhout
* [TeX for the Impatient](https://www.gnu.org/software/teximpatient/) - by Paul Abrahams, Kathryn Hargreaves, and Karl Berry

See also [LaTeX](#latex)


### Tizen
* [Tizen for Dummies](https://developer.tizen.org/sites/default/files/blogs/tizenfordummiesmainchangelist.pdf) (PDF) by Jon Lansdell, Cheng Luo, Michelle Somersville


### TLA
* [Specifying Systems: The TLA+ Language and Tools for Hardware and Software Engineers](http://research.microsoft.com/en-us/um/people/lamport/tla/book.html) (Postscript or PDF) by Leslie Lamport


### TypeScript
* [TypeScript Deep Dive](https://basarat.gitbooks.io/typescript/)
* [TypeScript for C# Programmers](http://www.infoq.com/minibooks/typescript-c-sharp-programmers)
* [TypeScript Succinctly, Syncfusion](http://www.syncfusion.com/resources/techportal/ebooks/typescript) (PDF, Kindle) *(Just fill the fields with any values)*


### Unix
* [An Introduction to Unix](http://www.oliverelliott.org/article/computing/tut_unix/)
* [Commentary on the Sixth Edition UNIX Operating System](http://www.lemis.com/grog/Documentation/Lions/) - J. Lions
* [UNIX Commands and Concepts](http://www.cs.bu.edu/teaching/unix/reference/) - Robert I. Pitts
* [Unix for Poets](http://www.stanford.edu/class/cs124/kwc-unix-for-poets.pdf) - Kenneth Ward Church (PDF)
* [Unix Toolbox](http://cb.vu/unixtoolbox.xhtml) - Colin Barschel
* [UNIX Tutorial for Beginners](http://www.ee.surrey.ac.uk/Teaching/Unix/)


### Verilog
* [Verilog Tutorial](http://www.asic-world.com/verilog/veritut.html)


### VHDL
* [Free Range VHDL](http://github.com/fabriziotappero/Free-Range-VHDL-book) (TeX and PDF) by Bryan Mealy, Fabrizio Tappero
* [VHDL Tutorial](http://www.seas.upenn.edu/~ese171/vhdl/vhdl_primer.html)
* [VHDL Tutorial](http://hep.uchicago.edu/~tangjian/SVT_sub/FTK_ATLAS/AUX/vhdl-tutorial.pdf) - Peter J. Ashenden
* [VHDL Tutorial: Learn By Example](http://esd.cs.ucr.edu/labs/tutorial/)


### Vim
* [A Byte of Vim](http://www.swaroopch.com/notes/vim/)
* [Learn Vim Progressively](http://yannesposito.com/Scratch/en/blog/Learn-Vim-Progressively/)
* [Learn Vimscript the Hard Way](http://learnvimscriptthehardway.stevelosh.com/)
* [Use Vim Like A Pro](https://leanpub.com/VimLikeAPro) *(Leanpub, by Tim Ottinger)*
* [Vi Improved -- Vim](http://www.truth.sk/vim/vimbook-OPL.pdf) (PDF) by Steve Oualline
* [Vim Recipes](http://ebooksgo.org/computer/vim-recipes.pdf) (PDF)
* [Vim Regular Expressions 101](http://vimregex.com/)


### Visual Basic
* [Visual Basic Essentials](http://www.techotopia.com/index.php/Visual_Basic_Essentials)


### Visual Prolog
* [A Beginners' Guide to Visual Prolog](http://wiki.visual-prolog.com/index.php?title=A_Beginners_Guide_to_Visual_Prolog)
* [Visual Prolog for Tyros](http://wiki.visual-prolog.com/index.php?title=Visual_Prolog_for_Tyros)


### Web Services
* [RESTful Web Services](http://restfulwebapis.org/RESTful_Web_Services.pdf) (PDF)


### Windows 8
* [Programming Windows 8 Apps with HTML, CSS, and JavaScript (v1)](http://blogs.msdn.com/b/microsoft_press/archive/2012/10/29/free-ebook-programming-windows-8-apps-with-html-css-and-javascript.aspx)
* [Programming Windows 8 Apps with HTML, CSS, and JavaScript (v2, incomplete)](http://blogs.msdn.com/b/microsoft_press/archive/2013/10/29/free-ebook-programming-windows-store-apps-with-html-css-and-javascript-second-edition-second-preview.aspx)


### Windows Phone
* [Developing An Advanced Windows Phone 7.5 App That Connects To The Cloud](http://coolthingoftheday.blogspot.co.uk/2012/05/free-ebook-guidance-advanced-windows.html)
* [Programming Windows Phone 7](http://blogs.msdn.com/b/microsoft_press/archive/2010/10/28/free-ebook-programming-windows-phone-7-by-charles-petzold.aspx)
* [Windows Phone 8 Development Succinctly](http://www.syncfusion.com/resources/techportal/ebooks/windowsphone8) (PDF) by Matteo Pagani
* [Windows Phone 8.1 Development for Absolute Beginners](http://channel9.msdn.com/Series/Windows-Phone-8-1-Development-for-Absolute-Beginners)
* [Windows Phone Programming Blue Book](http://www.robmiles.com/c-yellow-book/)


### Workflow
* [Declare Peace on Virtual Machines. A guide to simplifying vm-based development on a Mac](https://leanpub.com/declarepeaceonvms)


### xBase (dBase / Clipper / Harbour)
* [Application Development with Harbour](http://en.wikibooks.org/wiki/Application_Development_with_Harbour)
* [CA-Clipper 5.2 Norton Guide](http://www.ousob.com/ng/clguide/)
* [Clipper Tutorial: a Guide to Open Source Clipper(s)](http://en.wikibooks.org/wiki/Clipper_Tutorial%3A_a_Guide_to_Open_Source_Clipper(s))
